Package: brassica
Type: Package
Title: 1970s BASIC Interpreter
Version: 1.0.2
Date: 2022-10-24
Author: Mike Lee
Maintainer: Mike Lee <random.deviate@gmail.com>
Description: Executes BASIC programs from the 1970s, for historical and
    educational purposes. This enables famous examples of early machine
    learning, artificial intelligence, natural language processing, cellular
    automata, and so on, to be run in their original form.
License: GPL-3
Depends: R (>= 3.3.0)
NeedsCompilation: no
Packaged: 2022-10-24 01:16:01 UTC; Mike
Repository: CRAN
Date/Publication: 2022-10-24 06:15:06 UTC
Built: R 4.3.3; ; 2025-01-24 05:03:06 UTC; unix

Package: brassica
Type: Package
Title: 1970s BASIC Interpreter
Version: 1.0.3
Date: 2026-04-15
Authors@R: person(given = "Mike", family = "Lee", role = c("aut", "cre"),
                  email = "random.deviate@gmail.com")
Author: Mike Lee [aut, cre]
Maintainer: Mike Lee <random.deviate@gmail.com>
Description: Executes BASIC programs from the 1970s, for historical and
    educational purposes. This enables famous examples of early machine
    learning, artificial intelligence, natural language processing, cellular
    automata, and so on, to be run in their original form.
License: GPL-3
Depends: R (>= 3.3.0)
NeedsCompilation: no
Packaged: 2026-04-15 03:14:46 UTC; Mike
Repository: CRAN
Date/Publication: 2026-04-15 06:00:02 UTC
Built: R 4.6.0; ; 2026-04-26 13:33:02 UTC; unix

Interprets a generalised subset of 1975 Altair/Microsoft BASIC, sufficient to
run programs from:

* David H. Ahl and Steve North, _BASIC Computer Games_, Workman (1978)
* David H. Ahl and Steve North, _More BASIC Computer Games_, Workman (1980)

These contain many famous listings of historical interest, including early
examples of machine learning, natural language processing, artificial
intelligence, cellular automata, and Wumpus hunting.
A selection is included with the package (see below).



# Usage

To load and run the bundled 'Wumpus' program:

    import brassica
    brassica.run('wumpus')

To list the loaded program:

    brassica.list_program()

To load and run your own program:

    brassica.run('myprogram.bas')

To rerun the last program without reloading it:

    brassica.run()

To list which lines of the loaded program have not yet had all of their
statements successfully run (development tool):

    brassica.not_run()

To load and run the bundled 'Camel' program in teletype mode:

    brassica.run('camel', 20, 300, True)



# Bundled Programs

The following titles, from the above two books, are included in the package:

|Title|Authors, Contributors, and Creators|
|-----|-----------------------------------|
|_Camel_|The Heath Users Group|
|_Chase_|Mac Oglesby, Bill Cotter, Arnold Loveridge|
|_Eliza_|Jeff Shrager, Steve North, Joseph Weizenbaum|
|_Flip_|John S. James|
|_Inkblot_|Scott Costello|
|_Life_|Clark Baker, Steve North, John Conway, Martin Gardner|
|_Maze_|Richard Schaal, Jack Hauber|
|_Seabattle_|Vincent Erikson, Steve North|
|_Super Star Trek_|Robert Leedon, David H. Ahl, Mike Mayfield, Mary Cole, John Gorders|
|_Wumpus_|Gregory Yob|



# Guide to Brassica BASIC


## Lines

Line numbers label branching destinations, but are not strictly necessary
elsewhere.
Blank lines, numbered or not, are allowed.
Lines beginning with `#` are comments.
Colons separate multiple statements on the same line.
The presence or absence of horizontal whitespace makes no difference anywhere
outside of string literals, `DATA` values, and line numbers.
Aside from the names of variables, the interpreter is entirely case-insensitive.

    # infinite loop
    100
    110 let x = x + 1
        go to 100 : REM unnumbered line


## Variables

Legitimate names consist of a letter followed by zero or more alphanumeric
characters, possibly followed by a data-type indicator (`%` or `$`), possibly
followed by array subscripts.
Names are case-sensitive, not limited to two characters, and may not contain
reserved words (`TO`, `INT`, etc.).
Arrays of character strings are supported.
The six variables below are distinct and may coexist.
Subscripts begin from zero.
All BASIC variables are global in scope.
Variables may be referenced without prior definition, in which case numbers are
initialised to `0`, and strings to `""`.
Referencing an undimensioned array `DIM`s it as `0` - `10` (inclusive) on each
subscript.

    X             A numerical scalar.
    X%            An integer-constrained scalar (signed).
    X$            A character string.
    X(10)         A scalar element of a one-dimensional numerical array.
    X%(4,6)       A scalar element of a two-dimensional integer array.
    X$(0,0,0)     One string of a three-dimensional array of strings.


## Operators

In decreasing order of precedence:

    (...)               Bracketing (including functions).
    ^                   Exponentiation.
    unary + -           Identity and negation.
    * /                 Multiplication and division.
    + -                 Addition and subtraction.
    = <> < <= > >=      Relational operators.
    NOT                 Bitwise logical NOT.
    AND                 Bitwise logical AND.
    OR                  Bitwise logical OR.
    XOR                 Bitwise logical XOR.

Operators of equal precedence, such as the six relationals (equal to, not equal
to, less than, less than or equal to, greater than, greater than or equal to),
are applied in left-to-right order.
The equivalence operator is a single `=`, which is also used for the assignment
operator immediately after an expressed or implied `LET`.
Logically false relations evaluate to `0`, true relations to `-1`.
Whitespace is ignored; be wary of `F OR` and `X OR`.
Consecutive operators need not be separated by parentheses, but see below.

Relational operations are allowed between strings, and are case-insensitive
(hence, `"a" = "A"`).
Addition of strings performs concatenation.
Arguments of logical operators are coerced to integers.
`NOT(X%) = -(X% + 1)`.

The unary negation and logical NOT operators imply a bracketing extending to
(not around) the next operator of lower precedence.
The unary identity operator acts only on the value to its immediate right.
In effect, the unaries act as functions.
Hence;

    A^B^C = A^+B^C = (A^B)^C

while

    A^--B^C = A^-(-(B^C)) = A^(B^C)

and

    A * NOT B + NOT C + NOT D + E AND F
      = A * NOT(B + NOT(C + NOT(D + E))) AND F
      = A * ((NOT B) - (NOT C) + (NOT D) - E) AND F


## Commands

All BASIC statements begin with a command keyword.
The absence of an overt keyword implies `LET`.

#### CLEAR
Deletes all variables, arrays, and user-defined functions.
May be followed by a positive number, which is ignored.

#### DATA
Lists constant values for `READ`ing.

    DATA 3, 4.5E-2, REM, A B C, " D,:E "
    REM two numbers and three strings

#### DEF FN
Defines a custom function.
`FN` forms the beginning of its (case-sensitive) name, which must end with
the appropriate return-type indicator (`$`, `%`, or none).

    DEF FNA(X) = X + C
    DEF fnb$(A$,n) = MID$(A$,n,1)
    PRINT FNA(7) fnb$("ABC",2)

#### DELAY
Suspends execution for a time.
(Replaces delay loops.)

    DELAY 2   :REM waits two seconds

#### DIM
Specifies the domain of an array variable's subscripts.
Each subscript runs from zero to its specified limit (with both extremes
included).

    DIM A$(5), X(2,6)
    REM X has 3 * 7 = 21 elements

#### END
Terminates execution quietly.

#### FOR ... TO ... STEP
Begins a loop, iterating over some (non-array) variable.
The expression between `FOR` and `TO` is an implied `LET`, defining the
iterator.
The `STEP` (increment) is optional, and defaults to `1`.
The termination threshold, appearing after `TO`, is locked-in as a constant
when the loop is initiated.

    X=3: FOR I=1 TO X: PRINT I: X=10: NEXT
    REM prints 1, 2, 3.

Because the loop-termination condition is only tested at the bottom (by the
`NEXT`), loops always execute at least once.

    FOR I = 9 TO 5 STEP +2: PRINT I: NEXT
    REM this prints 9.

Beginning a new loop terminates any prior loop over the same iterator within the
same subroutine (see `GOSUB`).
Termination of a loop also terminates any loops nested within it.

    FOR I=1 TO 3: FOR J=1 TO 3: FOR I=1 TO 3
    NEXT I: NEXT J
    REM next-without-for error at the 'NEXT J'

#### GOSUB
Branches to a new subroutine.
The destination must be a constant literal line number.
While variables have global scope, loops are only visible within the subroutine
they were initiated in.
```
100 FOR I=1 TO 3: GOSUB 200
200 NEXT :REM next-without-for error here
```
```
10 REM this prints 1 2 5 6 8
20 FOR I=1 TO 8: PRINT I;
30 IF I=2 THEN GOSUB 50
40 NEXT I: PRINT: END
50 FOR I=5 TO 6: PRINT I;: NEXT I
60 RETURN
```

#### GOTO
Branches to a line number.
The destination must be a constant literal.
The word `GO` is reserved by BASIC in its own right.

    GOTO 840

#### IF ... GOTO
Conditional branching.
If the condition is true, execution jumps to the specified line.
Otherwise, execution continues with the next line.
Non-zero numbers and non-empty strings are considered true.

    IF X > 5 GOTO 1000

#### IF ... THEN
Conditional execution.
If the condition is true, execution continues along the same line.
If the condition is false, execution moves to the next line.
Non-zero numbers and non-empty strings are considered true.
```
IF X > 5 THEN 1000 :REM same as IF - GOTO
```
```
10 REM GOTO does the work of ELSE
20 IF A$ THEN X=X+1: GOSUB 500: GOTO 40
30 X=0: B$="Z"
40 REM line 30 is the ELSE block
```

#### INPUT
Accepts input from the terminal.
The user is automatically re-prompted on entering the wrong type or number of
comma-separated values.
(To enter a string with a comma in it, wrap it in double quotes.)

    INPUT           :REM just waits for enter
    INPUT X(4),Y$   :REM expects two values

An optional string-literal prompt can be printed.
It must be followed by either a semicolon (append the usual question mark) or a
comma (no question mark).

    INPUT "Coordinates";X,Y
    INPUT "[press enter]",

#### LET
Assigns a value to a variable.
The keyword is optional.
The data types of value and variable must match.
Non-integer numbers are floored when necessary.

    LET A$ = "Hi!"  :REM assigns "Hi!" to A$
    X = "A" = "a"   :REM assigns -1 to X
    N%(2.3) = 4.9   :REM assigns 4 to N%(2)

#### NEXT
Bottom of a loop.
Increments the iteration variable by the `STEP` defined when the loop was
initiated.
If the variable then exceeds the termination threshold, the loop terminates and
execution continues onward.
Otherwise, execution returns to the top of the loop.
If the iteration variable is not stated, `NEXT` applies to the most recent
loop.
When the `STEP` is non-negative, 'exceeds' means 'is greater than'.
When the `STEP` is negative, 'exceeds' means 'is less than'.
Terminating a loop also terminates any nested loop.
See `FOR` and `GOSUB`.

    FOR I = 8 TO 3 STEP -2: NEXT
    FOR J = -5 TO -2: FOR K = 1 TO 3: NEXT K,J
    REM at this point, I = 1, J = -1, K = 4

#### ON ... GOSUB
Branches to the *n*th of a list of subroutines.
If *n* should be zero, or exceed the number of subroutines, no branch is made,
and execution continues with the next statement.

    N = 2: ON N GOSUB 1000, 2000, 3000
    REM branches to the subroutine at line 2000

#### ON ... GOTO
Branches to the *n*th of a list of destinations.
If *n* should be zero, or exceed the number of destinations, no branch is made,
and execution continues with the next statement.

    ON INT(3*RND(1)+1) GOTO 500, 600, 700
    REM goes to one of these three lines

#### PRINT
Sends visible output to the terminal.
Numbers are printed with a trailing space.
Positive numbers also have a leading space (in lieu of a negative number's
sign).
(Use `STR$(X)` to suppress these.)
The width of the terminal is divided into 'print zones' of 14 spaces each.
Consider;

  PRINT A;BTAB(16)CHR$(34)SPC(4)":",C D$;

The first semicolon separates `A` from `B`, so we don't get the value of
`AB`.
No semicolon is needed after `B`, since the reserved word `TAB` cannot
be part of a variable's name.
`TAB(16)` moves the cursor to terminal-column 16, where `CHR$(34)` prints
a double-quote.
`SPC(4)` moves the cursor four more spaces to the right, where a colon is
printed.
The comma then moves the cursor to the beginning of the next print zone, where
the value of `CD$` is printed.
(Whitespace is ignored, including within keywords.)
The final semicolon says _not_ to print a newline at the end.

`TAB`, `SPC` and comma are rapid operations, in that they take essentially
no time even when teletypewriter-effect options are active.
They do not overprint existing text.
This is in contrast to printing spaces, which does take time, and does
overprint.
Cursor positioning and text-wrapping will be inaccurate when special characters,
such as a bell or tab, have been printed to the line.

#### READ
Assigns the next `DATA` value to a variable. See `RESTORE`.

    READ X,Y$  :REM read a number and a string

#### REM
A remark; the rest of the line is a comment.

#### RESTORE
Allows `DATA` to be `READ` again.

    RESTORE      :REM re-READ from the beginning
    RESTORE 600  :REM re-READ data from line 600

#### RETURN
Returns from a subroutine (to the point of `GOSUB`).

#### STOP
Terminates execution with a break message.


## Functions

|Function|Return Value|
|--------|------------|
|`ABS(X)`|Absolute value of `X`.|
|`ASC(X$)`|ASCII code of the first character of `X$`.|
|`ATN(X)`|Arctangent of `X`.|
|`CHR$(X)`|The character with ASCII value `X`.|
|`COS(X)`|Cosine of `X`.|
|`EXP(X)`|Natural exponential function of `X`.|
|`INT(X)`|Greatest integer less than or equal to `X` (floor function).|
|`LEFT$(X$,N)`|The leftmost `N` characters of `X$`.|
|`LEN(X$)`|The length, in characters, of `X$`.|
|`LOG(X)`|Natural logarithm of `X`.|
|`MID$(X$,I,N)`|An `N`-character substring of `X$`, starting from the `I`th (or all characters from the `I`th onward, if `N` is omitted).|
|`INSTR(N,X$,Y$)`|The position of the first occurrence of string `Y$` within string `X$`, not coming before the `N`th character (or the first, if `N` is omitted). Returns `0` when `X$` is empty, or when `Y$` does not appear.|
|`POS(1)`|Current position of the cursor across the console (the leftmost column is numbered zero).|
|`RND(X)`|A variate from the standard uniform distribution. Use `X = 1` for a new variate, or `X = 0` for the previous one.|
|`RIGHT$(X$,N)`|The rightmost `N` characters of `X$`.|
|`SGN(X)`|Sign (signum) function of `X`.|
|`SIN(X)`|Sine of `X`.|
|`SPC(X)`|Advances the cursor `X` spaces to the right (or left, if `X` is negative). Can only be used within `PRINT` statements.|
|`SQR(X)`|Square root of `X`.|
|`STR$(X)`|Converts `X` to character (string) representation.|
|`STRING$(N,X$)`|Concatenates `N` copies of `X$` (or `N` spaces, should `X$` be omitted).|
|`SYST(1)`|Current system date-time, in seconds.|
|`TAB(X)`|Positions the cursor at column `X` (or `-X` spaces in from the right margin, if `X` is negative). Can only be used within `PRINT` statements.|
|`TAN(X)`|Tangent of `X`.|
|`TTW(1)`|Width of the terminal, in characters.|
|`VAL(X$)`|Converts `X$` to its numerical value.|

The dummy argument to `POS`, `SYST`, and `TTW` must have the value `1`.
`POS` and `TAB` will be inaccurate when special characters (\a, \b, \t, etc.)
have been printed since the last carriage return.


## Identities

Functions on the left are not implemented directly.
Substitute expressions from the right.

    A MOD B     =   A-INT(A/B)*B
    LOG10(X)    =   LOG(X)/LOG(10)
    SEC(X)      =   1/COS(X)
    CSC(X)      =   1/SIN(X)
    COT(X)      =   1/TAN(X)
    ARCSIN(X)   =   ATN(X/SQR(1-X*X))
    ARCCOS(X)   =   1.5708-ATN(X/SQR(1-X*X)
    ARCSEC(X)   =   1.5708*SGN((X)-1)+ATN(SQR(X*X-1))
    ARCCSC(X)   =   1.5708*(SGN(X)-1)+ATN(1/SQR(X*X-1))
    ARCCOT(X)   =   1.5708-ATN(X)
    SINH(X)     =   (EXP(X)-EXP(-X))/2
    COSH(X)     =   (EXP(X)+EXP(-X))/2
    TANH(X)     =   1-2*EXP(-X)/(EXP(X)+EXP(-X))
    SECH(X)     =   2/(EXP(X)+EXP(-X))
    CSCH(X)     =   2/(EXP(X)-EXP(-X))
    COTH(X)     =   1+2*EXP(-X)/(EXP(X)-EXP(-X))
    ARSINH(X)   =   LOG(X+SQR(X*X+1))
    ARCOSH(X)   =   LOG(X+SQR(X*X-1))
    ARTANH(X)   =   LOG((1+X)/(1-X))/2
    ARSECH(X)   =   LOG((SQR(1-X*X)+1)/X)
    ARCSCH(X)   =   LOG((SQR(1+X*X)*SGN(X)+1)/X)
    ARCOTH(X)   =   LOG((X+1)/(X-1))/2
    PI          =   3.1416

# BASIC interpreter.
# MJL @ Titirangi, 3 August 2022.
# Last edit: 12 October 2022.

################################################################################
# Primary function.

RUN <- function(program = NULL, ttx = 0, tty = 0, up = FALSE)
{
  # Loads and runs a BASIC program, with optional teletypewriter aesthetics.
  # Args:
  #   program : The file path of a BASIC program listing,
  #               or NULL to re-run a program already loaded.
  #   ttx     : A pause, in milliseconds, after printing each character.
  #   tty     : A pause, in milliseconds, after printing each line.
  #   up      : Whether or not to print exclusively in upper case.
  # Note:
  #   A negative value for ttx or tty does not pause (as for a value of zero),
  #   but flushes the console after each complete line of printed output.
  # Returns:
  #   Invisible NULL. BASIC-program output will appear on standard output.
  ResetProgState()
  ResetHeapMemory()
  SetAesthetics(ttx, tty, up)
  if (length(program) > 0L) Load(program)
  GoToFirstDatum()
  GoToFirstStatement()
  while(Running() && WithinProgram()) Enact(GetStatement())
  PrintFinalBuffer()
  PrintExitMessage()
}

############################################################################ EOF

# Implements storage of BASIC data within an R environment.
# MJL @ Titirangi, 3 August 2022.

################################################################################
# Storage space for BASIC variables, functions, and arrays.

heapMemory <- new.env(parent = emptyenv())

################################################################################
# BASIC-variable initialisation constants.

initialString <- ""     # Initial value for a string-type variable.
initialNumber <- 0      # Initial value for a number-type variable.
defaultExtent <- 10L    # Default extent for each dimension of an array.

################################################################################
# Clear heap memory.

ResetHeapMemory <- function()
{
  # Delete all BASIC data storage objects (un-assigns all variables).
  remove(list = ls(heapMemory), pos = heapMemory)
}

################################################################################
# R-object setter and getter.

GetObject <- function(n)
{
  # Retrieves the storage-object named n, in its entirety.
  get(n, heapMemory)
}

ObjectExists <- function(n)
{
  # Returns TRUE if and only if a storage-object named n exists.
  # Returns FALSE otherwise.
  exists(n, heapMemory, inherits = FALSE)
}

SetObject <- function(n, v)
{
  # Assigns value v to the storage-object named n.
  assign(n, v, heapMemory)
}

################################################################################
# Functions acting upon R storage-object names.

CreateObject <- function(n, d)
{
  # Creates a storage-object of name n and BASIC (array) dimensions d.
  # For a singleton (non-array) object, d should be an empty integer vector.
  v <- InitialDatum(n)
  SetObject(n, if (length(d) == 0L) v else array(v, d + 1L))
}

InitialDatum <- function(n)
{
  # Returns the value to which the storage-object named n is initialised at the
  # time of its creation.
  if (TypeFromName(n) == basicS) initialString else initialNumber
}

################################################################################
# Functions acting upon R BASIC-data storage objects.

AssignVariable <- function(x, v, a)
{
  # Assigns BASIC-value a to the BASIC variable (or array element) referenced by
  # v and stored as R object x (or an element thereof).
  b <- if (IsIntegerValued(v)) floor(Value(a)) else Value(a)
  x[LinearisedIndex(x, v)] <- b
  SetObject(NameForObject(v), x)
}

DimensionalityOfObject <- function(x)
{
  # Returns the integer number of dimensions of storage-object x (zero, in the
  # case of a singleton non-array object).
  length(dim(x))
}

ExtentOfObject <- function(x)
{
  # Returns a vector of the (zero-indexed) BASIC array dimensions spanned by
  # (one-indexed) R storage-object x. That is, a return value of c(2, 3) means
  # x stores a BASIC array of those dimensions, e.g., A(2,3). These differ from
  # the R dimensions of x. Returns an empty vector when x is not an array.
  d <- dim(x)
  if (is.null(d)) integer() else d - 1L
}

LinearisedIndex <- function(x, v)
{
  # Maps an n-dimensional set of BASIC-variable reference (v) subscripts, each
  # starting at zero, to a single R storage-object (x) index, starting from one.
  # Includes zero-dimensional singleton (non-array) objects and variables.
  d <- ExtentOfObject(x)
  sum(cumprod(c(1L, d[-length(d)] + 1L)) * SubscriptsOfVariable(v)) + 1L
}

RetrieveValue <- function(x, v)
{
  # Extracts the BASIC value referenced by variable v from storage-object x.
  # Variable subscript validity checks should already have been performed.
  a <- x[LinearisedIndex(x, v)]
  if (IsStringValued(v)) AsString(a) else AsNumber(a)
}

SubscriptsMatch <- function(x, v)
{
  # Checks whether or not a storage-object, x, and a BASIC variable reference,
  # v, have the same number of dimensions (subscripts) and that x is large
  # enough to encompass the specific subscripts of v. Returns TRUE if and only
  # if this is the case, or FALSE otherwise. Subscripts must be evaluated to
  # integers before this is called.
  ((DimensionalityOfObject(x) == NumberOfSubscripts(v))
    && all(ExtentOfObject(x) >= SubscriptsOfVariable(v)))
}

################################################################################
# BASIC-variable reference-object constructor and getters.

NameOfVariable <- function(v)
{
  # Returns the name of the BASIC variable referenced by v, as a character
  # string. This includes the trailing $ or % in the case of string or integer
  # variables, respectively. Does not include the parenthesis or subscripts of
  # array-element references (only the name of the whole array).
  v[["name"]]
}

SubscriptsOfVariable <- function(v)
{
  # Returns the subscripts of BASIC variable reference v as either an integer
  # vector (of evaluated subscripts) or a character vector (of unevaluated BASIC
  # expressions). This is empty when the variable is dimensionless (has no
  # subscripts).
  v[["subscripts"]]
}

Variable <- function(n, i)
{
  # Constructs a BASIC variable reference object, for a variable of name n and
  # subscripts i. For singleton (non-array) references, i should be empty.
  # The subscripts, i, may be evaluated (to integers) or unevaluated strings
  # of BASIC expressions (ordinarily the latter). Besides the usual data-typed
  # variables, A, A$, etc., we also use these constructs for user-defined
  # functions, FNA(X). These have the same name-subscripts-value description,
  # and are indeed variable, but the subscripts need not be integers and the
  # (string) value is evaluated as code, rather than being taken at face value.
  list(name = unname(n), subscripts = i)
}

################################################################################
# Initialisation, assignment and recall of BASIC variables.

DimensionArray <- function(v)
{
  # Initialises a BASIC array of the name and dimensions in reference v.
  n <- NameForObject(v)
  if (ObjectExists(n)) return(SetRedimmedArrayError())
  i <- EvalSubscripts(SubscriptsOfVariable(v))
  if (Terminated()) return(Exit())
  CreateObject(n, i)
}

GetValue <- function(v)
{
  # Returns the value of the BASIC variable (or array element) referenced by v.
  # A default value will be created if the variable has not yet been assigned.
  v <- Variable(NameOfVariable(v), EvalSubscripts(SubscriptsOfVariable(v)))
  if (Terminated()) return(Exit())
  x <- GetOrCreateObject(v)
  if (!SubscriptsMatch(x, v)) return(SetBadSubscriptError())
  RetrieveValue(x, v)
}

SetValue <- function(v, a)
{
  # Assigns BASIC value a to the BASIC variable (or array element) referenced by
  # v. Returns a.
  v <- Variable(NameOfVariable(v), EvalSubscripts(SubscriptsOfVariable(v)))
  if (Terminated()) return(Exit())
  x <- GetOrCreateObject(v)
  if (!SubscriptsMatch(x, v)) return(SetBadSubscriptError())
  if (!TypesMatch(v, a)) return(SetTypeMismatchError())
  AssignVariable(x, v, a)
  a
}

################################################################################
# Functions acting upon BASIC-variable references.

DefaultExtent <- function(v)
{
  # Returns default BASIC array dimensions for initialising the BASIC variable
  # referenced by v when it has not already been defined by a DIM statement.
  # Returns and empty integer vector when v is a singleton (not an array).
  rep(defaultExtent, NumberOfSubscripts(v))
}

GetOrCreateObject <- function(v)
{
  # Retrieves the entirety of the R storage-object for the BASIC variable or
  # array referenced by v. If the storage-object does not already exist, it will
  # be created (with default dimensions and values) beforehand.
  n <- NameForObject(v)
  if (ObjectExists(n)) GetObject(n) else CreateObject(n, DefaultExtent(v))
}

IsArray <- function(v)
{
  # Returns TRUE if and only if the BASIC variable referenced by v is an element
  # of a BASIC array. Returns FALSE otherwise.
  NumberOfSubscripts(v) != 0L
}

IsIntegerValued <- function(v)
{
  # Returns TRUE if and only if the BASIC variable referenced by v is an integer
  # constrained number. Returns FALSE otherwise.
  IsIntegerConstrained(NameOfVariable(v))
}

IsNumberValued <- function(v)
{
  # Returns TRUE if and only if the BASIC variable referenced by v is a number.
  # Returns FALSE otherwise.
  TypeOfVariable(v) == basicN
}

IsStringValued <- function(v)
{
  # Returns TRUE if and only if the BASIC variable referenced by v is a string.
  # Returns FALSE otherwise.
  TypeOfVariable(v) == basicS
}

NameForObject <- function(v)
{
  # Maps the name of the BASIC variable referenced by v to the name of its R
  # data-storage object. In BASIC, X and X(1) are two different objects. We
  # prepend a marker to array names, rather than appending a '(', in order to
  # keep variable data-type checks simple (these look for a trailing '$').
  if (IsArray(v)) paste0("_", NameOfVariable(v)) else NameOfVariable(v)
}

NumberOfSubscripts <- function(v)
{
  # Returns the number of subscripts (dimensions) of BASIC variable reference v.
  length(SubscriptsOfVariable(v))
}

TypesMatch <- function(v, a)
{
  # Returns TRUE if and only if the BASIC data type of the variable (reference)
  # v matches that of the BASIC value a. Returns FALSE otherwise.
  TypeOfVariable(v) == Type(a)
}

TypeOfVariable <- function(v)
{
  # Returns the BASIC data type (string or number) of variable (reference) v.
  TypeFromName(NameOfVariable(v))
}

################################################################################
# Define and recall user-defined BASIC functions.

DefineFunction <- function(f, p, s)
{
  # Define a function, named f, of parameter variables named p, as the BASIC
  # expression of character string s. The parameters must all be singletons (no
  # arrays), and we store them by the names of their corresponding R-objects.
  # To distinguish the function from data-type objects, its name, f, necessarily
  # begins with 'FN' (or 'fn', etc.).
  n <- sapply(p, function(v) NameForObject(Variable(v, character())))
  SetObject(f, list(parameters = n, definition = s))
}

RecallFunction <- function(f)
{
  # Returns the definition of user-defined function named f. To distinguish the
  # function from data-type objects, its name, f, necessarily begins with 'FN'
  # (or 'fn', etc.).
  if (!ObjectExists(f)) return(SetUndefinedFunctionError())
  GetObject(f)
}

################################################################################
# Type utilities, acting on any name(s) (variable, function, or storage-object).

IsIntegerConstrained <- function(n)
{
  # Returns TRUE when string n names an integer-constrained variable, R storage
  # object, or user-defined function. Returns FALSE otherwise.
  substring(n, nchar(n)) == "%"
}

TypeFromName <- function(n)
{
  # Returns the data-type of a variable, or the return type of a user-defined
  # function, from either its name, or the associated R-object name, n. In
  # general, n can be a vector of names.
  c(basicN, basicS)[as.integer(substring(n, nchar(n)) == "$") + 1L]
}

############################################################################ EOF

# Evaluation and printing of PRINT statements (and INPUT prompts).
# MJL @ Titirangi, 11 August 2022.
# Last edit: 4 October 2022.

################################################################################
# Term separators. These symbols delimit individual PRINT terms, expand to
# varying amounts of whitespace when printed, and provide line-continuation by
# instructing BASIC not to append a newline.

separators <- c(";", ",")

################################################################################
# Formatting constants (tab width, floating point precision).

printZoneWidth <- 14L
printPrecision <- 6L

################################################################################
# Top-level print evaluators.

EvalPrintStatement <- function(s)
{
  # Evaluates, formats and prints each term of PRINT statement s.
  if (!nzchar(s)) return(PrintBufferAndNewline())
  a <- list()
  while (Running() && nzchar(s))
  {
    p <- EvalFirstPrintTerm(s)
    if (Terminated()) return(PrintFinalTerm(a))
    a <- append(a, p[-length(p)])
    s <- unname(p[[length(p)]])
    if (InteriorTermHasEnded(a[length(a)], s)) a <- AppendInteriorTerm(a)
  }
  if (Running()) PrintFinalTerm(a)
}

EvalFirstPrintTerm <- function(s)
{
  # Delegates the evaluation of the BASIC PRINT expression in string s to a
  # handler specific to the leading (left-most) term in that expression. Returns
  # the result of evaluating that first term in a list along with any remaining
  # unevaluated portion of the expression.
  if (BeginsWith("\"", s)) return(EvalString(s))
  if (BeginsWithAny(LETTERS, s)) return(EvalName(s))
  if (BeginsWithAny(separators, s)) return(IsolateSeparator(s))
  if (BeginsWith("(", s)) return(EvalGroup(s))
  if (BeginsWithAny(operators, s)) return(IsolateOperator(s))
  if (BeginsWithAny(digits, s)) return(EvalNumber(s))
  Interrupt(SetSyntaxError())
}

################################################################################
# Evaluation assistants.

AppendInteriorTerm <- function(a)
{
  # Evaluates a single PRINT term, formats the result for printing, and appends
  # it to the print buffer. List a comprises the term as a collection of BASIC
  # values and operators, followed by a separator. The collection may be empty,
  # or the separator absent (implied), but not both (list a cannot be empty).
  n <- length(a)
  s <- IsSeparator(a[n])
  if (n - s > 0L)
  {
    b <- if (s) a[-n] else a
    if (IsUnevaluated(b)) b <- EvalUnaryGroups(b)
    if (IsUnevaluated(b)) b <- ApplyBinaryOperators(b)
    if (IsUnevaluated(b)) return(SetSyntaxError())
    AppendToPrintBuffer(FormatPrintable(b))
  }
  if (s) AppendToPrintBuffer(FormatSeparator(a[n]))
  list()
}

FormatPrintable <- function(x)
{
  # Formats a BASIC string or number, x, to a print-ready R string.
  if (IsString(x)) return(Value(x))
  n <- toupper(format(Value(x), digits = printPrecision, decimal.mark = "."))
  if (BeginsWith("0.", n)) n <- substring(n, 2L) else
  if (BeginsWith("-0.", n)) n <- paste0("-", substring(n, 3L))
  paste0(strrep(" ", !BeginsWith("-", n)), n, " ")
}

FormatSeparator <- function(x)
{
  # Converts separation operator x to some number of spaces for printing. This
  # is always zero when using SkipToPrintZone() for comma separators. The
  # alternative function, SpaceToFillPrintZone(), produces variable whitespace,
  # which is subject to teletypewriter character printing delays.
  if (Value(x) == ";") "" else SkipToPrintZone()
}

InteriorTermHasEnded <- function(a, s)
{
  # Returns TRUE on reaching the end of an interior PRINT term. This occurs when
  # the last component of the current term, a, is a separator, a number followed
  # by something other than a binary operator, or a string followed by something
  # other than a string operator. When a is not a separator, and the remaining
  # unevaluated statement, s, is empty, this is a final term (not an interior
  # term). We have to look ahead on s, instead of just evaluating the next term,
  # in case it calls POS(1) (with the current term not yet committed to the
  # buffer).
  if (IsSeparator(a)) return(TRUE)
  if (!nzchar(s)) return(FALSE)
  if (IsString(a)) return(!BeginsWithAny(stringOps, s))
  if (IsNumber(a)) return(!BeginsWithAny(binaries, s))
  FALSE
}

IsolateSeparator <- function(s)
{
  # Detaches a separation operator from the beginning of statement s.
  # The operator is not applied at this time.
  o <- BeginsWithWhich(separators, s)
  Intermediate(AsOperator(o), substring(s, nchar(o) + 1L))
}

IsSeparator <- function(x)
{
  # Returns TRUE if x is a separation operator. Returns FALSE otherwise.
  IsOperator(x) && any(Value(x) == separators, na.rm = TRUE)
}

PrintFinalTerm <- function(a)
{
  # Evaluates a single PRINT term, formats the result for printing, and appends
  # it to the print buffer. List a contains the term as a collection of BASIC
  # data values and operators. The list can be empty, but cannot end with a
  # term separator (comma or semicolon).
  if (length(a) < 1L) return(NULL)
  if (IsUnevaluated(a)) a <- EvalUnaryGroups(a)
  if (IsUnevaluated(a)) a <- ApplyBinaryOperators(a)
  if (IsUnevaluated(a)) return(SetSyntaxError())
  AppendToPrintBuffer(FormatPrintable(a))
  PrintBufferAndNewline()
}

SkipToPrintZone <- function()
{
  # Rapidly advances the cursor to the beginning of the next print zone (tab
  # stop, without teletype print-speed restrictions). Inaccurate when the print
  # buffer contains special or non-printing characters.
  p <- VirtualCursorPosition()
  s <- printZoneWidth - p %% printZoneWidth
  w <- TerminalWidth()
  if ((p + s) < w) AdvancePrintHead(s) else PrintBufferAndNewline()
  ""
}

SpaceToFillPrintZone <- function()
{
  # Returns a character string of however many spaces are required to advance
  # the cursor to the first column of the next print zone (i.e., tab stop).
  # Inaccurate if the print buffer contains special or non-printing characters.
  # These spaces are subject to teletype delays, and this function has been
  # replaced with SkipToPrintZone(). We retain it, in case we want those delays.
  p <- VirtualCursorPosition()
  w <- printZoneWidth - p %% printZoneWidth
  if ((p + w) < TerminalWidth()) return(strrep(" ", w))
  PrintBufferAndNewline()
  ""
}

################################################################################
# Printing utilities.

AdvancePrintHead <- function(n)
{
  # Rapidly advances the print head n spaces; in a single movement and without
  # actually printing anything (i.e., without teletype effects). This has no
  # protection against overshooting the console; wrapping is to be done before
  # calling this function. When printed material on the line extends beyond the
  # current cursor position, we have to re-cat it, so as not to overprint it.
  PrintNonEmptyBuffer()
  k <- GetCursorPosition()
  p <- GetCharactersOnLine()
  z <- substring(p, k + 1L, k + n)
  z <- paste0(z, strrep(" ", max(0L, n - nchar(z))))
  UpdateCharactersOnLine(z)
  cat(z, sep = "")
}

Print <- function(s)
{
  # Concatenates character vector s to standard output.
  # In teletype mode, this goes one character at a time, pausing after each.
  p <- CharacterPause()
  z <- paste0(if (UpperCaseOut()) toupper(s) else s, collapse = "")
  UpdateCharactersOnLine(z)
  if (p == 0) return(cat(z, sep = ""))
  z <- strsplit(z, "", fixed = TRUE)[[1L]]
  for (x in z)
  {
    cat(x, sep = "")
    flush.console()
    Sys.sleep(p)
  }
}

PrintBufferAndNewline <- function()
{
  # Prints the print buffer, empty or not, followed by a newline.
  PrintPrintBuffer()
  PrintNewLine()
}

PrintCarriageReturn <- function()
{
  # Prints a carriage return. Pauses afterward, if in teletype mode.
  cat("\r")
  p <- LinePause()
  if (p != 0) flush.console()
  if (p > 0) Sys.sleep(p)
  ResetCursorPosition()
}

PrintExitMessage <- function()
{
  # Prints the exit message, then immediately deletes it from program memory.
  # For use at the very end of a RUN(), after a program has terminated.
  m <- GetExitMessage()
  if (any(nzchar(m))) {Print(m); PrintNewLine()}
  DelPro(exitTrigger)
}

PrintFinalBuffer <- function()
{
  # Prints anything sitting in the print buffer, then prints a new line if the
  # current line is not empty (these two actions are independent). Called on
  # termination of a BASIC program, just before printing any exit message.
  PrintNonEmptyBuffer()
  if (nzchar(GetCharactersOnLine())) PrintNewLine()
}

PrintNewLine <- function()
{
  # Prints a newline. Pauses afterward, if in teletype mode.
  cat("\n")
  p <- LinePause()
  if (p != 0) flush.console()
  if (p > 0) {Sys.sleep(p)}
  ResetCursorPosition()
  SetNoCharactersOnLine()
}

PrintNonEmptyBuffer <- function()
{
  # Prints the print buffer (without newline), only if the buffer is non-empty.
  if (AnythingInPrintBuffer()) PrintPrintBuffer()
}

PrintNonEmptyLine <- function()
{
  # Prints the print buffer and a newline, only if the buffer is non-empty.
  if (AnythingInPrintBuffer()) PrintBufferAndNewline()
}

PrintPrintBuffer <- function()
{
  # Sends the print buffer (even when empty) to standard output, and immediately
  # deletes its content (after printing).
  Print(GetPrintBuffer())
  ClearPrintBuffer()
}

RetractPrintHead <- function(n)
{
  # Rapidly retracts the print head n spaces toward, but not beyond, the left
  # margin, without teletype effects. We do this the long way, via a carriage
  # return and AdvancePrintHead(), so that R's cursor position is in agreement.
  PrintNonEmptyBuffer()
  k <- GetCursorPosition()
  cat("\r")
  ResetCursorPosition()
  AdvancePrintHead(max(0L, k - n))
}

################################################################################
# Seek user input.

PromptForInput <- function(p)
{
  # Present the user with an input prompt, '?', an addenda prompt, '??', or no
  # prompt, '', as specified by integer p, and accept one line of input.

  a <- switch(p, "? ", "?? ")

  # When a teletype character delay is in effect, we print the buffer first, so
  # that the effect is applied. In some R sessions (*) this may result in the
  # input prompt appearing on the next line (i.e., after a newline), or at the
  # beginning of the current line (with user input overprinting the prompt).
  # While unaesthetic, this is not fatal.
  # (*) Affected: Windows terminal (R & Rterm; but the Rgui console is fine),
  # Mac console (but the terminal is fine; opposite to Windows), RStudio.
  if (CharacterPause() > 0)
  {
    PrintPrintBuffer()
    Print(a)
    a <- trimws(readline())

  # When no teletype character delay is in effect (and need not be applied),
  # we print the buffer via readline's prompt argument. This works in all R
  # sessions (the input prompt appears where we want it), although the prompt
  # will be coloured in some.
  } else
  {
    a <- paste0(c(GetPrintBuffer(), a), collapse = "")
    a <- trimws(readline(if (UpperCaseOut()) toupper(a) else a))
    ClearPrintBuffer()
  }

  ResetCursorPosition()
  SetNoCharactersOnLine()
  a
}

IssueRedoFromStartWarning <- function()
{
  # Advise the user of an issue with their input (too much or wrong type; too
  # little merely results in the addenda prompt), and that we're starting over.
  Print("? Redo from start")
  PrintNewLine()
}

############################################################################ EOF

# Implements the action of BASIC commands (beginning with a keyword).
# MJL @ Titirangi, 3 August 2022.
# Last edit: 28 September 2022.

################################################################################
# Recognised BASIC keywords (commands).

keywords <- c("CLEAR", "DATA", "DEF", "DELAY", "DIM", "ELSE", "END", "FN",
              "FOR", "GO", "GOSUB", "GOTO", "IF", "INPUT", "LET", "NEXT", "ON",
              "PRINT", "READ", "REM", "RESTORE", "RETURN", "STEP", "STOP",
              "THEN", "TO")

################################################################################
# Named components of composite data structures.

variable  <- "variable"
variables <- "variables"
remainder <- "remainder"

################################################################################
# Top-level statement processor.

Enact <- function(s)
{
  # Top-most BASIC-statement processing function. Identifies the primary command
  # keyword of statement s, and calls the appropriate method for handling it.
  if (Terminated()) return(Exit())
  a <- WhichAction(s)
  eval(call(paste0("Enact", a), Trim(s, if (a == "None") "" else a)))
}

################################################################################
# Utilities for the top-level processor.

Trim <- function(s, w)
{
  # Removes as many characters as are in word w from the beginning of string s.
  substring(s, nchar(w) + 1L)
}

WhichAction <- function(s)
{
  # Returns the leading BASIC keyword (command) of statement s, or 'None' in the
  # absence of such.
  if (length(k <- BeginsWithWhich(keywords, s)) != 0L) k else "None"
}

################################################################################
# Implied actions when no leading keyword is present.

EnactImpliedGOTO <- function(s)
{
  # A string of digits after THEN is an implied GOTO (that line number).
  EnactGOTO(s)
}

EnactImpliedLET <- function(s)
{
  # No keyword at the beginning of a non-blank statement is an implied LET.
  EnactLET(s)
}

EnactNone <- function(s)
{
  # No keyword at the beginning of a statement is either an implied LET
  # assignment (when the statement is non-blank), or simply a do-nothing (when
  # the statement is blank). Although supported here, blank statements are not
  # found in original BASIC.
  if (nzchar(s)) return(EnactImpliedLET(s))
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

################################################################################
# Actions for each BASIC command (keyword).

EnactCLEAR <- function(s)
{
  # Performs a CLEAR; deletes everything in heap memory (does not affect either
  # the loop or subroutine return-point stacks). In 8K Altair BASIC, CLEAR <N>
  # deletes everything in heap memory and allocates <N> (bytes?) for character
  # string storage. Here, we ignore <N>, so long as it is a positive number.
  if (nzchar(s))
  {
    n <- Eval(s)
    if (!IsNumber(n)) return(SetTypeMismatchError())
    if (Value(n) < 0) return(SetIllegalQuantityError())
  }
  ResetHeapMemory()
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactDATA <- function(s)
{
  # Actions DATA statements at run-time (when they are are skipped-over).
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactDEF <- function(s)
{
  # Actions DEF FN definition of custom user-functions. A function must have at
  # least one parameter variable, even if this is just a dummy. Here, we allow
  # multiple parameters of any data type (number, integer, or string). Many
  # original flavours of BASIC insisted on precisely one parameter, of number
  # type only. Parameters cannot have subscripts (no array elements allowed).
  # Here, functions may return numbers or strings, and must have the usual type
  # suffix, $, for the latter. Number-valued functions may possess the integer
  # suffix, %, in which case their output will be appropriately constrained.
  # Many original BASICs only support unconstrained number-valued definitions.
  if (!BeginsWith("FN", s)) return(SetSyntaxError())
  # DetachLeadingVariable() will raise an error on 'FN'.
  a <- DetachLeadingVariable(Trim(s, "FN"))
  v <- a[[variable]]
  if (!IsArray(v)) return(SetSyntaxError())
  # Restore the 'FN' (or 'fn', etc.) to the case-sensitive function name, n.
  n <- paste0(substring(s, 1L, 2L), NameOfVariable(v))
  p <- SubscriptsOfVariable(v)
  # Check all parameter names are singletons (no subscripted array-members).
  if (!all(grepl("[[:alpha:]][[:alnum:]]*[%$]{0,1}$", p)))
    return(SetSyntaxError())
  if (any(duplicated(p))) return(SetDuplicatedParameterError())
  s <- a[[remainder]]
  if (!BeginsWith("=", s)) return(SetSyntaxError())
  s <- substring(s, 2L)
  if (!nzchar(s)) return(SetSyntaxError())
  DefineFunction(n, p, s)
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactDELAY <- function(s)
{
  # Actions DELAY commands, for pausing execution for some amount of time.
  n <- Eval(s)
  if (!IsNumber(n)) return(SetTypeMismatchError())
  if (Value(n) < 0) return(SetIllegalQuantityError())
  PrintPrintBuffer()
  flush.console()
  Sys.sleep(Value(n))
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactDIM <- function(s)
{
  # Actions a DIM command, for dimensioning one or more arrays.
  a <- SplitArguments(s)
  if (Terminated()) return(Exit())
  for (b in a)
  {
    v <- DetachLeadingVariable(b)
    if (Terminated()) return(Exit())
    if (nzchar(v[[remainder]])) return(SetSyntaxError())
    DimensionArray(v[[variable]])
    if (Terminated()) return(Exit())
  }
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactELSE <- function(s)
{
  # It is an error for a statement to begin with ELSE, which should appear only
  # after IF and THEN, as part of an IF - THEN - ELSE statement.
  SetSyntaxError()
}

EnactEND <- function(s)
{
  # Actions END commands. These set a blank exit message to halt program
  # execution and terminate quietly.
  if (nzchar(s)) return(SetSyntaxError())
  MarkStatementAsChecked()
  SetEndMessage()
}

EnactFN <- function(s)
{
  # It is an error for a statement to begin with FN, which should appear only
  # after DEF, or within an arithmetical expression within some other statement.
  SetSyntaxError()
}

EnactFOR <- function(s)
{
  # Implements FOR - TO - STEP commands. These define a looping condition to be
  # checked by NEXT. This function is only called to initialise the loop, not on
  # every iteration. Because the looping condition is not checked at this (FOR)
  # point, BASIC loops always execute at least once (this was the case for early
  # versions of BASIC, but not for later versions). While it would be easier to
  # process the STEP term first, we work in left-to-right order so that the user
  # is notified of the leftmost error (should one occur).
  a <- DetachLeadingVariable(s)
  if (Terminated()) return(Exit())
  v <- a[[variable]]
  s <- a[[remainder]]
  if (!IsNumberValued(v) || IsArray(v)) return(SetSyntaxError())
  if (!BeginsWith("=", s)) return(SetSyntaxError())
  i <- PositionOfFirst("TO", s)
  if (i < 1L) return(SetSyntaxError())
  a <- Eval(substring(s, 2L, i - 1L))
  if (!IsNumber(a)) return(SetTypeMismatchError())
  s <- substring(s, i + 2L)
  i <- PositionOfFirst("STEP", s)
  b <- Eval(if (i < 1L) s else substring(s, 0L, i - 1L))
  if (!IsNumber(b)) return(SetTypeMismatchError())
  if (i < 1L) d <- AsNumber(1) else
  {
    d <- Eval(substring(s, i + 4L))
    if (!IsNumber(d)) return(SetTypeMismatchError())
  }
  SetValue(v, a)
  if (Terminated()) return(Exit())
  InitiateLoop(v, b, d)
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactGO <- function(s)
{
  # GO on its own is an error. While a reserved word, it should only appear as
  # part of GOTO or GOSUB.
  SetSyntaxError()
}

EnactGOSUB <- function(s)
{
  # Actions GOSUB commands. The subroutine must be given as an integer literal.
  if (!grepl("^[[:digit:]]+$", s)) return(SetUndefinedStatementError())
  i <- which(GetLineNumbers() == as.integer(s))
  if (length(i) != 1L) return(SetUndefinedStatementError())
  PushReturnPoint(GetPoint())
  MarkStatementAsChecked()
  ScopeSubroutineLoops()
  GoToStartOfLine(i)
}

EnactGOTO <- function(s)
{
  # Actions GOTO commands. The destination must be given as an integer literal.
  if (!grepl("^[[:digit:]]+$", s)) return(SetUndefinedStatementError())
  i <- which(GetLineNumbers() == as.integer(s))
  if (length(i) != 1L) return(SetUndefinedStatementError())
  MarkStatementAsChecked()
  GoToStartOfLine(i)
}

EnactIF <- function(s)
{
  # Actions IF - GOTO, IF - THEN, and IF - THEN - ELSE statements. The statement
  # will only be marked as checked after a THEN, ELSE, or GOTO sub-statement has
  # been successfully executed. This admits the possibility that an alternative
  # (THEN or ELSE) sub-statement might still contain an error.
  i <- PositionOfFirst("THEN", s)
  g <- PositionOfFirst("GOTO", s)
  if ((g > 0L) && ((i < 0L) || (g < i))) i <- g
  if (i < 1L) return(SetSyntaxError())
  k <- IsFalse(Eval(substring(s, 0L, i - 1L)))
  if (Terminated()) return(Exit())
  s <- substring(s, i + 4L)
  if (i == g) return(if (k) AdvanceToStartOfNextLine() else EnactGOTO(s))
  j <- PositionOfPairedELSE(s)
  if (k && (j < 0L)) return(AdvanceToStartOfNextLine())
  if (j > 0L) s <- if (k) substring(s, j + 4L) else substring(s, 0L, j - 1L)
  if (grepl("^[[:digit:]]+$", s)) return(EnactImpliedGOTO(s))
  Enact(s)
}

EnactINPUT <- function(s)
{
  # Actions INPUT statements, through which user-input is entered.

  # Specifies the default input prompt.
  p <- 1L

  # The INPUT keyword may be immediately followed by an optional string literal.
  # If so, append it to the print buffer. The string must be followed by either
  # a semicolon (display the default input prompt) or a comma (do not display
  # any input prompt). Set p accordingly.
  i <- as.integer(gregexpr("\"", s, fixed = TRUE)[[1L]])
  if (i[1L] == 1L)
  {
    if (length(i) > 1L) i <- i[2L] else return(SetSyntaxError())
    p <- substring(s, i + 1L, i + 1L)
    if (!any(p == c(",", ";"))) return(SetSyntaxError())
    AppendToPrintBuffer(substring(s, 2L, i - 1L))
    s <- substring(s, i + 2L)
    p <- as.integer(p == ";")
  }

  # The statement should end with a comma-separated list of zero or more
  # variables to be assigned. Separate these.
  v <- list()
  if (nzchar(s))
  {
    v <- DetachLeadingVariables(s)
    if (Terminated()) return(Exit())
    if (nzchar(v[[remainder]])) return(SetSyntaxError())
    v <- v[[variables]]
  }

  # Accept as many comma-separated input items from the user as there are
  # variables to assign (or one item, in the no-variable case). If the user
  # enters too few items, the addendum prompt is displayed and the remainder are
  # sought. If the user enters too many items, or an item of the wrong data type
  # (not-a-number, where a number was expected), a warning is issued and we
  # start over. Human errors here are non-fatal.
  a <- list()
  u <- PromptForInput(p)
  while (length(a) < length(v))
  {
    for (s in ScanData(u))
    {
      if (length(a) >= length(v)) {p <- -1L; break}
      d <- DatumToVariable(v[[length(a) + 1L]], s)
      if (IsError(d)) {p <- -1L; break}
      a <- append(a, list(d))
    }
    if (p < 0L) {IssueRedoFromStartWarning(); a <- list()}
    if (length(a) == length(v)) break
    p <- as.integer(sign(length(a))) + 1L
    u <- PromptForInput(p)
  }

  # Assign all variables (if any), before moving on to the next statement.
  if (length(v) > 0L) mapply(SetValue, v, a)
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactLET <- function(s)
{
  # Actions LET commands (assigns values to variables). The first = in a LET
  # statement is the assignment operator; any others being comparisons.
  a <- DetachLeadingVariable(s)
  if (Terminated()) return(Exit())
  x <- a[[variable]]
  s <- a[[remainder]]
  if (!BeginsWith("=", s)) return(SetSyntaxError())
  v <- Eval(substring(s, 2L))
  if (Terminated()) return(Exit())
  SetValue(x, v)
  if (Terminated()) return(Exit())
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactNEXT <- function(s)
{
  # Actions NEXT commands. The statement s can be empty (tests the most recent
  # loop), or a comma-separated list of variable names (each tests that specific
  # loop). Unlike EnactFOR(), this function is called on every iteration. A loop
  # is only broken when the iterator exceeds its goal; merely equalling the goal
  # results in one more iteration. By 'exceed', we mean 'greater than' when the
  # step is non-negative, and 'less than' when the step is negative.
  r <- ""
  v <- NULL
  if (nzchar(s))
  {
    v <- DetachLeadingVariable(s)
    if (Terminated()) return(Exit())
    r <- v[[remainder]]
    v <- v[[variable]]
  }
  p <- GetLoopParameters(v)
  if (Terminated()) return(Exit())
  if (!nzchar(r)) MarkStatementAsChecked()
  v <- p[[variable]]
  g <- Value(p[["goal"]])
  s <- Value(p[["step"]])
  a <- Value(GetValue(v)) + s
  SetValue(v, AsNumber(a))
  s <- if (s < 0) -1 else 1
  if (sign(a - g) != s) return(LoopAgain(p))
  ConcludeLoop(p)
  if (nzchar(r))
  {
    if (!BeginsWith(",", r) || (nchar(r) < 2L)) return(SetSyntaxError())
    return(EnactNEXT(substring(r, 2L)))
  }
  AdvanceToNextStatement()
}

EnactON <- function(s)
{
  # Actions ON - GOTO/GOSUB commands. The switching number, k, between ON and
  # GOTO or GOSUB, cannot be negative. Destinations, after the GOTO or GOSUB,
  # must be integer literals. The program will jump to the k-th destination. If
  # k is zero, or exceeds the number of destinations, the ON command is ignored,
  # and the program moves on to the next statement. It is an error for k to be
  # negative. The statement is not marked as checked until the GOTO or GOSUB has
  # been successfully executed.
  i <- PositionOfFirst("GO", s)
  if (i < 1L) return(SetSyntaxError())
  k <- Eval(substring(s, 0L, i - 1L))
  if (!IsNumber(k)) return(SetTypeMismatchError())
  k <- as.integer(floor(Value(k)))
  if (k < 0L) return(SetIllegalQuantityError())
  if (k == 0L) return(AdvanceToNextStatement())
  r <- substring(s, i, i + 5L)
  g <- if (BeginsWith("GOTO", r)) "GOTO" else
        if (BeginsWith("GOSUB", r)) "GOSUB" else return(SetSyntaxError())
  s <- ScanData(substring(s, i + nchar(g)))
  if (k > length(s)) return(AdvanceToNextStatement())
  eval(call(paste0("Enact", g), s[k]))
}

EnactPRINT <- function(s)
{
  # Evaluates, formats, and prints each term of PRINT statement s.
  EvalPrintStatement(s)
  if (Terminated()) return(PrintNonEmptyLine())
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactREAD <- function(s)
{
  # Actions READ statements, wherein each variable of a comma-separated list is
  # assigned the next inline DATA item.
  u <- DetachLeadingVariables(s)
  if (Terminated()) return(Exit())
  if (nzchar(u[[remainder]])) return(SetSyntaxError())
  for (v in u[[variables]])
  {
    s <- GetDatum()
    if (Terminated()) return(Exit())
    d <- DatumToVariable(v, s)
    if (IsError(d)) return(SetTypeMismatchError())
    SetValue(v, d)
    if (Terminated()) return(Exit())
  }
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactREM <- function(s)
{
  # Actions REM remarks. Being comments, these are skipped-over.
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactRESTORE <- function(s)
{
  # Actions RESTORE commands. The command word may optionally be followed by a
  # number (literal or variable). In the absence of that number, the data
  # pointer resets to the first inline BASIC DATA item. In the presence of that
  # number, the data pointer moves to the first datum on the first line with a
  # BASIC line number not less than the RESTORE number. The original flavours of
  # BASIC had differing capabilities with regard to the RESTORE number (allowed,
  # only literal integer constants allowed, or not supported at all).
  if (!nzchar(s)) GoToFirstDatum() else
  {
    n <- Eval(s)
    if (!IsNumber(n)) return(SetTypeMismatchError())
    SeekData(n)
  }
  MarkStatementAsChecked()
  AdvanceToNextStatement()
}

EnactRETURN <- function(s)
{
  # Actions a RETURN command, to move the program back to the first statement
  # after the last GOSUB.
  if (nzchar(s)) return(SetSyntaxError())
  p <- PopReturnPoint()
  if (Terminated()) return(Exit())
  MarkStatementAsChecked()
  DropSubroutineLoops()
  GoToFirstStatementAfter(p)
}

EnactSTEP <- function(s)
{
  # It is an error for a statement to begin with STEP, which should only appear
  # after FOR and TO, as part of a FOR - TO - STEP statement.
  SetSyntaxError()
}

EnactSTOP <- function(s)
{
  # Actions STOP commands. These terminate the program with a break message.
  if (nzchar(s)) return(SetSyntaxError())
  MarkStatementAsChecked()
  SetBreakMessage()
}

EnactTHEN <- function(s)
{
  # It is an error for a statement to begin with THEN, which should appear only
  # after IF, as part of an IF - THEN statement.
  SetSyntaxError()
}

EnactTO <- function(s)
{
  # It is an error for a statement to begin with TO, which should only appear
  # after FOR, as part of a FOR - TO - <STEP> statement.
  SetSyntaxError()
}

################################################################################
# Parsing of BASIC-variable names.

DetachLeadingVariable <- function(s)
{
  # Extracts the BASIC variable at the beginning of (partial) statement s, and
  # returns that variable, along with the remainder of the statement, in a list.
  # If s does not begin with a variable, a syntax error is raised.
  i <- EndOfLeadingName(s)
  if (i < 1L) return(SetSyntaxError())
  j <- PositionOfClosingParenthesis(substring(s, i + 1L))
  k <- if (j < 1L) character() else
        SplitArguments(substring(s, i + 2L, i + j - 1L))
  v <- Variable(substring(s, 0L, i), k)
  list(variable = v, remainder = substring(s, i + j + 1L))
}

DetachLeadingVariables <- function(s)
{
  # Extracts all of the comma-separated variables from partial statement s, and
  # returns them in a list, along with the remainder of s.
  v <- list()
  while (Running())
  {
    a <- DetachLeadingVariable(s)
    if (Terminated()) return(Exit())
    v <- append(v, unname(a[variable]))
    s <- a[[remainder]]
    if (substring(s, 1L, 1L) != ",") break
    s <- substring(s, 2L)
  }
  list(variables = v, remainder = s)
}

EndOfLeadingName <- function(s)
{
  # Returns the position of the last character of the name at the beginning of
  # string s, or 0 or -1 if no such name is there. A name is one alphabetical
  # character followed by a (possibly empty) string of alphanumerics before up
  # to one type identifier (% or $), and does not include any BASIC reserved
  # word (command keyword, function, or logical operator).
  i <- attr(regexpr("^[[:alpha:]][[:alnum:]]*[%$]{0,1}", s), "match.length")
  j <- PositionOfFirstReservedWord(substring(s, 0L, i))
  if (j > i) return(i)
  # Override the greedy algorithm in these cases; to read F OR, G OR, T OR, or
  # T AND. Since EnactFOR() does not call this function, we still read FOR and
  # TO R in the definition of a FOR loop (necessitating parentheses in the case
  # of FOR I = (T) OR U TO V). GO R and TAN D would be syntax errors in any
  # situation. Parentheses are still required for X OR (as in A < (BX) OR C).
  if (BeginsWithAny(c("FOR", "GOR", "TOR", "TAND"), substring(s, j, j + 3L)))
    j else j - 1L
}

PositionOfFirst <- function(w, s)
{
  # Returns the position of the first case-insensitive appearance of word w
  # within string s, but not within a string literal. Returns -1 when w does not
  # appear within s.
  i <- Uncontained(toupper(w), toupper(s), "\"")
  if (length(i) < 1L) -1L else i[1L]
}

PositionOfFirstReservedWord <- function(s)
{
  # Returns the position of the first appearance of any reserved BASIC word
  # (keyword, function, or operator) within non-empty string s, which should
  # consist of an alphabetic character followed by zero or more alphanumeric
  # characters and an optional trailing % or $. The magic numbers 2 and 6 come
  # about from all reserved words being between 2 and 7 characters. While it is
  # possible to split s on numeric characters and loop over smaller words, that
  # is slower than matching on one big table (which grows as nchar(s)^2). It is
  # also slower to pre-filter the reserved words (on the letters of s) with
  # regular expressions. While it would be possible to insert a line 'if any(
  # r == w) return(1)' before the match, for faster detection of the whole of s
  # being a reserved word, this ultimately results in faster syntax errors, at
  # the expense of slower normal operations. Returns one more than the number of
  # characters in s when no reserved word is present.
  n <- nchar(s)
  y <- substring(s, n, n)
  m <- n - as.integer(any(y == c("$", "%", seq(0, 9))))
  if (m < 2L) return(n + 1L)
  r <- GetReservedWords(m, y == "$")
  u <- rep(seq(n - 1L), c(rep(6L, max(n - 7L, 0L)), seq(min(n - 1L, 6L), 1L)))
  v <- unlist(mapply(seq, seq(2L, n), mapply(min, seq(7L, n + 5L), n)))
  w <- !is.na(match(substring(toupper(s), u, v), r))
  if (any(w)) return(u[which(w)[1L]])
  n + 1L
}

PositionOfPairedELSE <- function(s)
{
  # String s immediately follows a THEN (not included in s). This function
  # returns the position, within s, of the ELSE paired with that leading THEN.
  # Returns -1 when no such ELSE exists.
  u <- toupper(s)
  k <- PositionsOf("\"", u)
  i <- Unenclosed("ELSE", u, k)
  if (length(i) == 0L) return(-1L)
  j <- Unenclosed("THEN", u, k)
  if (length(j) == 0L) return(i[1L])
  i <- i[(sapply(i, function(a, b) sum(a > b), j) - seq_along(i)) < 0L]
  if (length(i) == 0L) return(-1L)
  i[1L]
}

Uncontained <- function(w, s, z)
{
  # Returns all positions of character (or word) w within string s that do not
  # lie between a pair of delimiting characters (or words, typically quotation
  # marks) z, according to the even/odd delimiter-count rule. Case sensitive.
  u <- PositionsOf(w, s)
  v <- PositionsOf(z, s)
  u[as.logical(sapply(u, function(a, b) sum(a > b) %% 2L == 0L, v))]
}

################################################################################
# Data readers (including user input).

DatumToNumber <- function(s)
{
  # Converts R-string s (being user-input or a DATA item) to a BASIC number.
  # Whereas BASIC expressions require numeric literals to contain at least a
  # digit or decimal point (before the E, if any), INPUT and READ do not. Valid
  # numeric data includes +, -, ., E, and blank. An absence of digits is treated
  # as zero (on either side of any E or .). Multiple Es, decimal points after
  # any E, and consecutive sign operators, are not allowed. Returns a non-fatal
  # error on failure.
  w <- toupper(gsub("[[:blank:]]+", "", s))
  p <- "^[+-]{0,1}[.]{0,1}(E[+-]{0,1}[[:digit:]]*){0,1}$"
  if (!nzchar(w) || grepl(p, w)) return(AsNumber(0))
  n <- try(suppressWarnings(as.numeric(w)), silent = TRUE)
  if (!inherits(n, "try-error") && is.finite(n)) return(AsNumber(n))
  AsError("Failed Numeric Conversion")
}

DatumToString <- function(s)
{
  # Converts R-string s (being user-input or a DATA item) to a BASIC string, by
  # removing leading and trailing quotes only when a leading quote is present.
  AsString(if (BeginsWith("\"", s)) gsub("^\"|\"$", "", s) else s)
}

DatumToVariable <- function(v, s)
{
  # Converts R-string s (being either user-input or a DATA item) to a BASIC
  # string or number, whichever is appropriate for variable v. Returns a non-
  # fatal error in response to conversion failure.
  if (IsStringValued(v)) DatumToString(s) else DatumToNumber(s)
}

ScanData <- function(s)
{
  # Picks comma-separated values (inline or user-input) out of string s, for use
  # with DATA, INPUT, or ON commands. BASIC takes no action on any keywords in
  # data, so 'DATA 1REM,2,3' scans to three items, rather than one and a remark.
  # Colons still split statements, so 'DATA 1:REM,2' contains one data point. We
  # leave encasing quotes in place, because while 'DATA 5' can be READ to string
  # or number type, 'DATA "5"' can only be READ as a string. Data items with an
  # opening quotation mark need not have a closing one.
  i <- Uncontained(",", s, "\"")
  substring(s, c(1L, i + 1L), c(i - 1L, nchar(s)))
}

################################################################################
# BASIC to R logical truth of value conversion.

IsFalse <- function(x)
{
  # Returns TRUE (FALSE) if BASIC-value x is regarded as logically false (true)
  # in BASIC. Sets a syntax error when x is not a value type.
  if (IsNumber(x)) return(Value(x) == 0)
  if (IsString(x)) return(!nzchar(Value(x)))
  SetSyntaxError()
}

IsTrue <- function(x)
{
  # Returns TRUE (FALSE) if BASIC-value x is regarded as logically true (false)
  # in BASIC. Sets a syntax error when x is not a value type.
  if (IsNumber(x)) return(Value(x) != 0)
  if (IsString(x)) return(nzchar(Value(x)))
  SetSyntaxError()
}

############################################################################ EOF

# BASIC data type definitions, casting, and testing.
# MJL @ Titirangi, 3 August 2022.

# BASIC expressions are evaluated to data objects (mainly numbers and strings,
# but also errors and operators), consisting of a value wrapped in a named list
# (the name being that of the data type). Even so, many functions throughout
# will equally handle named, unnamed, or empty lists and vectors, and NULLs.
# Errors return data objects as a simple expediency. Likewise, operators are
# treated as data objects until such time as they are applied.

################################################################################
# BASIC data-type names.

basicB <- "basicB"    # Break message.
basicE <- "basicE"    # Error message.
basicN <- "basicN"    # Numerical value.
basicO <- "basicO"    # Operator.
basicS <- "basicS"    # Character string.

################################################################################
# BASIC-datum type and value extractors.

Caseless <- function(x)
{
  # Returns the underlying R value of BASIC datum x, but raised to upper case
  # when x is a string. Used to make case-insensitive relational comparisons.
  if (IsString(x)) toupper(Value(x)) else Value(x)
}

Type <- function(x)
{
  # Returns the type (name) of BASIC datum x.
  # In general, x can be a list of data, resulting in a vector of types.
  names(x)
}

Value <- function(x)
{
  # Returns the underlying (unnamed) R value of (named) BASIC datum x.
  x[[1L]]
}

################################################################################
# BASIC type casters.

AsBreak <- function(m)
{
  # Flags m as being a break result (message).
  # The unname(unlist()) calls remove any list wrapper and any prior names.
  list(basicB = unname(unlist(m)))
}

AsError <- function(m)
{
  # Flags m as being an error result (message).
  # The unname(unlist()) calls remove any list wrapper and any prior names.
  list(basicE = unname(unlist(m)))
}

AsNumber <- function(n)
{
  # Flags n as being an evaluated BASIC numerical value.
  # The as.numeric() call removes any list wrapper, removes any prior names, and
  # casts R integers to R numerics.
  list(basicN = as.numeric(n))
}

AsOperator <- function(s)
{
  # Flags s as being an unapplied BASIC operator.
  # The as.character() call removes any list wrapper and any prior names.
  list(basicO = as.character(s))
}

AsString <- function(s)
{
  # Flags s as being an evaluated BASIC character string.
  # The as.character() call removes any list wrapper and any prior names.
  list(basicS = as.character(s))
}

################################################################################
# BASIC type checkers.

IsBreak <- function(x)
{
  # Returns TRUE if x is a BASIC break result (message).
  # Otherwise returns FALSE, including if x is NULL or untyped.
  IsType(x, basicB)
}

IsError <- function(x)
{
  # Returns TRUE if x is a BASIC error result (message).
  # Otherwise returns FALSE, including if x is NULL or untyped.
  IsType(x, basicE)
}

IsNumber <- function(x)
{
  # Returns TRUE if x is a fully evaluated BASIC number.
  # Otherwise returns FALSE, including if x is NULL or untyped.
  IsType(x, basicN)
}

IsOperator <- function(x)
{
  # Returns TRUE if x is an unapplied BASIC operator.
  # Otherwise returns FALSE, including if x is NULL or untyped.
  IsType(x, basicO)
}

IsString <- function(x)
{
  # Returns TRUE if x is a fully evaluated BASIC string.
  # Otherwise returns FALSE, including if x is NULL or untyped.
  IsType(x, basicS)
}

IsType <- function(x, y)
{
  # Returns TRUE if and only if x is a BASIC datum of type y.
  # Otherwise returns FALSE, including if x is NULL or untyped.
  (length(x) == 1L) && any(Type(x) == y, na.rm = TRUE)
}

############################################################################ EOF

# BASIC program storage, state, and flow.
# MJL @ Titirangi, 3 August 2022.
# Last edit: 15 October 2022.

################################################################################
# Storage space for one BASIC program and its run-state.

progMemory <- new.env(parent = emptyenv())

################################################################################
# Constant object names.

# Reserved words.
reservedWords     <- "rw" # BASIC keywords, functions, and logical operators.

# Program storage.
basicProgram      <- "bp" # Raw program listing, as it appears in the file.
basicStatements   <- "bs" # Program listing, deconstructed to statements.
checkedStatements <- "cs" # Logs which statements have successfully executed.
dataQueue         <- "dl" # Character vector of all data items in the program.
fileLineNumbers   <- "fn" # Source-file line number of each program line.
lineNumbers       <- "ln" # The BASIC line number of each program line.

# Program state.
cursorPosition    <- "cp" # Zero-indexed console column of the print cursor.
dataIndex         <- "di" # Index number of the next data item to read.
exitTrigger       <- "et" # The first error or break condition to have occurred.
lastRandomNumber  <- "lr" # The last pseudo-random variate generated.
lineIndex         <- "li" # Index number of the current program line.
loopPoints        <- "lp" # FOR-loop return points and conditions.
printBuffer       <- "pb" # Character strings, ready to be printed.
printedChars      <- "pc" # Characters already printed on the current line.
returnPoints      <- "rp" # GOSUB return-point stack (for RETURN commands).
statementIndex    <- "si" # Index of the current statement on the current line.

# Aesthetic options.
ttCharDelay       <- "tx" # Teletypewriter delay after printing each character.
ttLineDelay       <- "ty" # Teletypewriter delay after printing each line.
upperCase         <- "uc" # Whether or not to force upper-case printing.

################################################################################
# Derived constant lists.

# BASIC-program storage objects to delete before loading a new program.
progStore <- c(basicProgram, basicStatements, checkedStatements, dataQueue,
                fileLineNumbers, lineNumbers)

# BASIC-program run-state objects to delete before beginning a new run.
# (The last random number is not to be deleted in this situation).
progState <- c(cursorPosition, dataIndex, exitTrigger, lineIndex, loopPoints,
                printBuffer, printedChars, returnPoints, statementIndex)

################################################################################
# Clear program memory.

ResetProgFull <- function()
{
  # Delete the program and its state, leaving only the (constant) reserved words
  # look-up table, and the initial random number, on an otherwise clean slate.
  remove(list = ls(progMemory), pos = progMemory)
  SetReservedWords()
  GetNewRandomNumber()
}

ResetProgMemory <- function()
{
  # Deletes the program and its run-state, without affecting the reserved words
  # table, the random number generator, or any aesthetic options.
  s <- ls(progMemory)
  remove(list = s[s %in% c(progState, progStore)], pos = progMemory)
}

ResetProgState <- function()
{
  # Deletes the program run-state, without touching aesthetic options or the
  # loaded program. Ensures the reserved words table is loaded, and that the
  # pseudo-random number generator is primed.
  s <- ls(progMemory)
  remove(list = s[s %in% progState], pos = progMemory)
  SetReservedWords()
  GetNewRandomNumber()
}

################################################################################
# Low-level setter and getter for objects in program memory.

DelPro <- function(a)
{
  # Deletes the object named a from program memory, if it exists there.
  if (exists(a, progMemory, inherits = FALSE)) rm(list = a, pos = progMemory)
}

GetPro <- function(a, b)
{
  # Retrieves the object named a from program memory, returning default value b
  # if a is not found there.
  get0(a, progMemory, inherits = FALSE, ifnotfound = b)
}

SetPro <- function(a, b)
{
  # Assigns value b to an object named a, stored within program memory.
  assign(a, b, progMemory)
}

################################################################################
# Load-time program pre-processing and inline data extraction.

LineHasStatement <- function(p)
{
  # Returns TRUE for those lines of program listing p that are neither blank nor
  # a comment (hence contain a program statement), and FALSE for those that are
  # (blanks or comments). Comments are lines having # as the first non-blank.
  # (REM remarks are loaded and interpreted, comments are not.)
  !grepl("^[[:blank:]]*(#|$)", p)
}

Load <- function(f)
{
  # Loads a BASIC program from file (named) f. This can either be supplied by
  # the user as an external file (within their file space), or else bundled
  # within the R package's namespace.
  ResetLineIndex()
  p <- ReadExternal(f)
  if (is.null(p)) p <- ReadBundled(f)
  if (is.null(p)) return(SetFileNotFoundError())
  ResetProgMemory()
  RetainProgramVerbatim(p)
  LoadStatements(p)
  LoadData()
}

LoadData <- function()
{
  # Scans the stored program for inline DATA statements, and transcribes all
  # such data to a vector in program-memory for run-time convenience. BASIC
  # does not detect DATA not at the very beginning of its statement (as is the
  # case for, say, 'IF 1=1 THEN DATA 1,2,3'). Note that 'DATA ,,' and 'DATA'
  # (with nothing after it) are both allowed. This is read as an empty string
  # (which becomes a zero if coerced to number-type). DATA and REM statements
  # are marked as checked here, at load time (statements of either type are
  # ignored at run time, and it is not uncommon for them to be inaccessible).
  k <- GetChecks()
  s <- GetStatements()
  n <- GetLineNumbers()
  n[is.na(n)] <- -1L
  n <- cummax(n)
  d <- character()
  for (i in seq_along(s))
  {
    k[[i]] <- BeginsWith("DATA", s[[i]])
    for (b in s[[i]][k[[i]]])
    {
      a <- ScanData(Trim(b, "DATA"))
      names(a)[1L] <- as.character(n[i])
      d <- c(d, a)
    }
    k[[i]] <- k[[i]] | BeginsWith("REM", s[[i]])
  }
  SetChecks(k)
  SetData(d)
}

LoadStatements <- function(p)
{
  # Deconstructs BASIC program listing p to its constituent statements, and
  # stores them, along with their BASIC line numbers and source-file line
  # numbers, within program-memory space.

  # Source-file line numbers (fl) and the text on each line (lt).
  fl <- seq_along(p)
  lt <- trimws(p)

  # Remove blank and comment lines, leaving only those containing statements.
  i <- LineHasStatement(lt)
  fl <- fl[i]
  lt <- lt[i]

  # Split BASIC line numbers (bl) from the line text (lt).
  i <- attr(regexpr("^[[:digit:]]+", lt), "match.length")
  bl <- as.integer(substring(lt, 1L, i))
  lt <- trimws(substring(lt, i + 1L))

  # Check BASIC line numbers are unique and monotonically increasing.
  i <- bl[!is.na(bl)]
  if (any(duplicated(i))) return(SetRedefinedLineError())
  if (!all(i == cummax(i))) return(SetLineOutOfSequenceError())

  # Locate colons (statement separators), quotes (string delimiters), DATAs
  # (literal data markers), and REMs (remarks; comment markers). BASIC keywords
  # have precedence over everything else, so, unless a REM is a string literal
  # (within quotes or data), everything after it goes unseen. Hence the line
  # '100 LET A=XREMY:DATA 1,2,3' contains no data, while '100 DATAREM,1:DATA2'
  # contains three data items ('REM', 1, and 2).
  ic <- gregexpr(":", lt, fixed = TRUE)
  iq <- gregexpr("\"", lt, fixed = TRUE)
  ir <- gregexpr("REM", lt, ignore.case = TRUE)
  id <- gregexpr("DATA", lt, ignore.case = TRUE)

  # Split each line into its constituent statements.
  ps <- as.list(lt)
  for (i in seq_along(ps))
  {
    # Locate colons on this line.
    jc <- ic[[i]][ic[[i]] > 0L]
    if (length(jc) == 0L) next

    # Locate quotes, REMs and DATAs on this line.
    jq <- iq[[i]][iq[[i]] > 0L]
    jr <- ir[[i]][ir[[i]] > 0L]
    jd <- id[[i]][id[[i]] > 0L]

    # Disregard markers within string literals, by the even/odd quotes rule.
    jc <- jc[as.logical(sapply(jc, function(a, b) sum(a > b) %% 2L == 0L, jq))]
    jr <- jr[as.logical(sapply(jr, function(a, b) sum(a > b) %% 2L == 0L, jq))]
    jd <- jd[as.logical(sapply(jd, function(a, b) sum(a > b) %% 2L == 0L, jq))]

    # Disregard REMs within DATA statements (treated as string literals).
    if ((length(jc) > 0L) && (length(jr) > 0L) && (length(jd) > 0L))
    {
      kc <- sapply(jr, function(x, y) max(c(-1L, y[y < x])), jc)
      kd <- sapply(jr, function(x, y) max(c(-2L, y[y < x])), jd)
      jr <- jr[kc > kd]
    }

    # Disregard colons within remarks (everything after the first active REM).
    if ((length(jc) > 0L) && (length(jr) > 0L)) jc <- jc[jc < jr[1L]]

    # Split the line into statements.
    if (length(jc) > 0L)
    {
      a <- substring(ps[[i]], c(1L, jc + 1L), c(jc, nchar(ps[[i]])))
      ps[[i]] <- trimws(gsub("^:|:$", "", a))
    }
  }

  # Remove whitespace from each line, excepting that on the interior of string
  # literals and data items (quoted or not). Other than these, BASIC pretty much
  # ignores whitespace, and removing it before run-time makes life easier. The
  # necessity of treating DATA statements differently from others, compels us to
  # perform this action after, not before, reducing the program to statements.
  d <- "^D[[:blank:]]*A[[:blank:]]*T[[:blank:]]*A"
  for (i in seq_along(ps))
  {
    k <- attr(regexpr(d, ps[[i]], ignore.case = TRUE), "match.length")
    for (j in which(k < 0L)) ps[[i]][j] <- SpaceFreeLine(ps[[i]][j])
    for (j in which(k > 0L)) ps[[i]][j] <- SpaceFreeData(ps[[i]][j], k[j])
  }

  # Load the source-file line numbers (fl), the corresponding BASIC program line
  # numbers (bl), and the associated BASIC program statements (ps), into memory.
  SetFileLineNumbers(fl)
  SetLineNumbers(bl)
  SetStatements(ps)
}

ProgramListing <- function()
{
  # Retrieves the original BASIC program listing from memory.
  # This only happens when the user calls LIST() to take a look at it.
  GetPro(basicProgram, character())
}

ReadBundled <- function(f)
{
  # If f is the name of an included BASIC program, return that program as a
  # character vector. Otherwise, return NULL.
  g <- tolower(gsub("[[:blank:]_-]+", "", f))
  g <- system.file("BASIC", paste0(g, ".bas"), package = "brassica")
  ReadExternal(g)
}

ReadExternal <- function(f)
{
  # If f is the name of a readable file, return its content as a character
  # vector. Otherwise, return NULL.
  if (!inherits(f, class(character()))
      || (length(f) != 1L)
      || !file.exists(f)
      || (file.access(f, 4L) != 0L)
      || file.info(f)$isdir)
    return(NULL)
  readLines(f)
}

RetainProgramVerbatim <- function(p)
{
  # Keeps an unmodified copy of the original BASIC program listing.
  # This copy is not used anywhere, except when the user requests a LIST().
  SetPro(basicProgram, p)
}

SetAesthetics <- function(ttx, tty, up)
{
  # Sets teletypewriter-effect control parameters: the delay after printing each
  # character, the delay after printing each line (carriage return), and whether
  # or not to convert all output to upper case.
  SetTeletypeCharDelay(ttx)
  SetTeletypeLineDelay(tty)
  SetUpperCaseOut(up)
}

SetData <- function(d)
{
  # Stores the vector of inline BASIC-program DATA, d, in program-memory.
  SetPro(dataQueue, d)
}

SetFileLineNumbers <- function(n)
{
  # Stores the vector of source-file line numbers, n, in program memory.
  SetPro(fileLineNumbers, n)
}

SetLineNumbers <- function(n)
{
  # Stores the vector of BASIC line numbers, n, in program memory.
  SetPro(lineNumbers, n)
}

SetStatements <- function(s)
{
  # Stores a BASIC program as a list of its statements, s, and marks each of
  # those statements as unchecked (not yet successfully executed).
  SetPro(basicStatements, s)
  MarkStatementsAsUnchecked()
}

SpaceFreeData <- function(s, n)
{
  # Removes unnecessary whitespace from BASIC DATA statement s, being everything
  # except that within a string literal or strictly within a datum (whether
  # quoted or not). Integer n marks the end of the DATA keyword.
  a <- gsub("[[:blank:]]+", "", substring(s, 1L, n))
  b <- substring(s, n + 1L)
  i <- c(0L, Uncontained(",", b, "\""), nchar(b) + 1L)
  b <- substring(b, i[-length(i)] + 1L, i[-1L] - 1L)
  paste0(a, paste0(trimws(b), collapse = ","))
}

SpaceFreeLine <- function(s)
{
  # Removes unnecessary whitespace from any BASIC statement, s, besides a DATA
  # statement (for those, use SpaceFreeData()). Unnecessary whitespace in this
  # context is everything except that within string literals.
  i <- c(-1L, 0L, PositionsOf("\"", s))
  i <- c(i, nchar(s) + seq(length(i) %% 2L, 1L) + 1L)
  j <- i + c(0L, 1L)
  k <- i + c(-1L, 0L)
  s <- substring(s, j[-length(j)], k[-1L])
  s[c(FALSE, TRUE)] <- gsub("[[:blank:]]+", "", s[c(FALSE, TRUE)])
  paste0(s, collapse = "")
}

################################################################################
# Reserved-word look-up table.

SetReservedWords <- function()
{
  # Builds a constant look-up table of BASIC's reserved words, at load-time.
  # Since the table is a constant, we don't rebuild it if it already exists.
  w <- GetPro(reservedWords, NULL)
  if (!is.null(w)) return(w)
  w <- c(keywords, functions, operatorWords)
  w <- w[order(nchar(w), w)]
  i <- grepl("[$]$", w)
  u <- w[!i]
  v <- w[i]
  j <- nchar(u)
  k <- nchar(v)
  m <- max(j, k - 1L)
  r <- vector(mode(list()), m)
  for (i in seq_along(r))
    r[[i]] <- list(u[j <= i], sort(c(u[j <= i], v[k <= i + 1L])))
  r[[1L]] <- list(m, m)
  SetPro(reservedWords, r)
}

GetReservedWords <- function(n, s)
{
  # Returns a character vector of BASIC's reserved words containing n or fewer
  # alphanumeric characters, during run-time. If s is TRUE, the vector includes
  # words ending with '$' (making n + 1 characters in total). When s is FALSE,
  # those words are omitted. The special case of n = 1 returns the length of the
  # longest reserved word (7 characters, for RESTORE).
  w <- GetPro(reservedWords, NULL)
  w[[min(n, length(w))]][[as.integer(s) + 1L]]
}

################################################################################
# Run-time retrieval of BASIC DATA, for READ commands.

AdvanceToNextDatum <- function()
{
  # Increment the data index, ready to read the next datum in the list.
  SetDataIndex(GetDataIndex() + 1L)
}

GetDataIndex <- function()
{
  # Returns the value of the data index.
  GetPro(dataIndex, 1L)
}

GetDataQueue <- function()
{
  # Returns the entire data list.
  GetPro(dataQueue, character())
}

GetDatum <- function()
{
  # Returns the current datum from the list, and advances to the next.
  d <- GetDataQueue()
  i <- GetDataIndex()
  if (length(d) < i) return(SetOutOfDataError())
  AdvanceToNextDatum()
  unname(d[i])
}

GoToFirstDatum <- function()
{
  # Resets the data index to the first datum in the list.
  SetDataIndex(1L)
}

SeekData <- function(n)
{
  # Moves the data index to the first datum on the first program line numbered
  # not less than BASIC number n. Moves beyond the list when n is too large.
  m <- as.integer(names(GetDataQueue()))
  SetDataIndex(min(which(m >= Value(n)), length(m) + 1L))
}

SetDataIndex <- function(i)
{
  # Moves the data index to position number i (which can be beyond the list).
  SetPro(dataIndex, i)
}

################################################################################
# Program-counter line index.

AdvanceToStartOfNextLine <- function()
{
  # Advances the program counter to the first statement on the next line.
  SetLineIndex(GetLineIndex() + 1L)
  GoToFirstStatementOnLine()
}

CountProgramLines <- function()
{
  # Returns the total number of lines in the stored BASIC program.
  length(GetFileLineNumbers())
}

GetLineIndex <- function()
{
  # Returns the sequential index number of the current program line.
  GetPro(lineIndex, 0L)
}

GoToFirstLine <- function()
{
  # Goes to the first line, without altering the statement index.
  SetLineIndex(1L)
}

GoToStartOfFirstLine <- function()
{
  # Goes to the first statement of the first line (to the start of the program).
  # Does the same thing as GoToFirstStatement().
  GoToFirstLine()
  GoToFirstStatementOnLine()
}

GoToStartOfLine <- function(i)
{
  # Goes to the first statement (the start) of the i-th line (by line index, not
  # by BASIC line number).
  SetLineIndex(i)
  GoToFirstStatementOnLine()
}

ResetLineIndex <- function()
{
  # Moves the line index out-of-program, prior to loading another program when
  # one has been run previously.
  SetLineIndex(0L)
}

SetLineIndex <- function(i)
{
  # Moves to the i-th line (by index), without changing the statement index.
  SetPro(lineIndex, i)
}

WithinProgram <- function()
{
  # Returns TRUE if the line index lies within the range of the stored BASIC
  # program. Returns FALSE otherwise (including when no program is loaded).
  i <- GetLineIndex()
  (i > 0L) && (i <= CountProgramLines())
}

################################################################################
# Program-counter statement index.

AdvanceToNextStatement <- function()
{
  # Advances the program counter to the next statement.
  # This might be on the current line, or the next.
  i <- SetStatementIndex(GetStatementIndex() + 1L)
  if (i > CountStatementsOnLine()) AdvanceToStartOfNextLine()
}

CountStatementsOnLine <- function()
{
  # Returns the number of statements on the current line of the program.
  length(GetStatementsOnLine())
}

GetStatementIndex <- function()
{
  # Returns the index of the current statement on the current line. This is line
  # relative; the second statement on line 100 has index 2, as does the second
  # statement on line 5000.
  GetPro(statementIndex, 1L)
}

GoToFirstStatement <- function()
{
  # Resets the program counter to the first statement of the first line (i.e.,
  # goes to the start of the BASIC program, same as GoToStartOfFirstLine()).
  GoToFirstLine()
  GoToFirstStatementOnLine()
}

GoToFirstStatementOnLine <- function()
{
  # Goes to the first statement on the current line (without changing lines).
  SetStatementIndex(1L)
}

SetStatementIndex <- function(i)
{
  # Moves to the i-th statement on the current line. That statement need not
  # exist (there is no protection against overshooting, here).
  SetPro(statementIndex, i)
}

################################################################################
# Full program-counter setter and getter (for loops and subroutines).

GetPoint <- function()
{
  # Returns the program counter as a (line-index, statement-index) ordered pair.
  # (Returns the current position in the program.)
  c(GetLineIndex(), GetStatementIndex())
}

SetPoint <- function(p)
{
  # Sets the program counter from a (line-index, statement-index) ordered pair.
  # (Goes to that position in the program.)
  SetLineIndex(p[1L])
  SetStatementIndex(p[2L])
}

################################################################################
# GOSUB (subroutine) return-point stack.

GetReturnPoints <- function()
{
  # Retrieves the entire return-point stack.
  GetPro(returnPoints, list())
}

GoToFirstStatementAfter <- function(p)
{
  # Moves to the statement immediately following the GOSUB at point p.
  SetPoint(p)
  AdvanceToNextStatement()
}

PopReturnPoint <- function()
{
  # Pops the last return-point (removes it from the stack before returning it).
  p <- GetReturnPoints()
  if (length(p) < 1L) return(SetReturnWithoutGosubError())
  SetReturnPoints(p[-length(p)])
  p[[length(p)]]
}

PushReturnPoint <- function(p)
{
  # Pushes a return-point, p, onto the top of the stack.
  SetReturnPoints(append(GetReturnPoints(), list(p)))
}

SetReturnPoints <- function(p)
{
  # Saves p as the entire return-point stack, in program memory.
  SetPro(returnPoints, p)
}

################################################################################
# FOR (loop) return-point stack.

FindLoop <- function(p)
{
  # Locates loop p within the loop-stack of the current subroutine scope, and
  # returns its index (or -1, if p does not appear within the loop-stack). A
  # special case is p = NULL, for which the most recent loop is returned.
  u <- GetLoops()
  if (length(u) < 1L) return(-1L)
  if (is.null(p)) return(length(u))
  i <- names(u) == LoopName(p)
  if (!any(i)) return(-1L)
  min(which(i))
}

GetAllLoops <- function()
{
  # Returns the list of loop definitions across all subroutine levels.
  GetPro(loopPoints, list(list()))
}

GetLoops <- function()
{
  # Returns the list of loop definitions for the current subroutine level.
  p <- GetAllLoops()
  p[[length(p)]]
}

LoopName <- function(p)
{
  # Returns the name of loop p (by which it is identified in the loop stack).
  NameForLoop(p[[variable]])
}

NamedLoop <- function(p)
{
  # Embeds loop object p in a named list, for appending to the loop stack.
  a <- list(p)
  names(a) = LoopName(p)
  a
}

NameForLoop <- function(v)
{
  # Returns the (loop stack) name of the loop over variable v.
  # Presently, this is the same as the variable's R storage-object's name.
  NameForObject(v)
}

NewLoop <- function(v, g, s)
{
  # Initiates a new FOR loop, iterating over variable v, in increments of step
  # s, until exceeding goal g, at the current point in the program.
  list(point = GetPoint(), variable = v, goal = g, step = s)
}

SetAllLoops <- function(p)
{
  # Sets the entire list of loop definitions, for all subroutine levels.
  SetPro(loopPoints, p)
}

SetLoops <- function(p)
{
  # Sets the list of loop definitions, for the current subroutine level.
  a <- GetAllLoops()
  a[[length(a)]] <- p
  SetAllLoops(a)
}

################################################################################
# FOR (loop) program flow controls.

ConcludeLoop <- function(p)
{
  # Removes loop p from the stack, after its termination condition has been met,
  # or on beginning a new loop over the same iterator. Concluding loop p also
  # concludes any nested (subsequently initiated) loops. No action is performed
  # when loop p does not appear in the stack.
  i <- FindLoop(p)
  if (i > 0L) SetLoops(GetLoops()[seq(0L, i - 1L)])
}

DropSubroutineLoops <- function()
{
  # On RETURNing from a subroutine, this concludes all loops created within it
  # and drops the scoping level, reverting to the loops of the previous level.
  a <- GetAllLoops()
  SetAllLoops(a[-length(a)])
}

GetLoopParameters <- function(v)
{
  # Returns the parameters (return-point, iterator variable, stopping condition,
  # and iteration increment) of the FOR loop associated with variable v. If such
  # a loop exists, it is unique. If v is NULL, the most recent loop is returned.
  u <- GetLoops()
  if (length(u) < 1L) return(SetNextWithoutForError())
  if (is.null(v)) return(u[[length(u)]])
  if (!IsNumberValued(v) || IsArray(v)) return(SetNextWithoutForError())
  p <- u[[NameForLoop(v)]]
  if (is.null(p)) return(SetNextWithoutForError())
  p
}

InitiateLoop <- function(v, g, s)
{
  # Initiates a new loop, iterating over variable v, in increments of step s,
  # until exceeding goal g, within the current subroutine scoping level, at the
  # current point in the program. If another loop over the same iterator already
  # exists within the same scope, that pre-existing loop is concluded (dropped),
  # along with any nested loops.
  p <- NewLoop(v, g, s)
  ConcludeLoop(p)
  SetLoops(append(GetLoops(), NamedLoop(p)))
}

LoopAgain <- function(p)
{
  # Moves the program counter to the first statement after the top (the defining
  # FOR statement) of loop p.
  SetPoint(p[["point"]])
  AdvanceToNextStatement()
}

ScopeSubroutineLoops <- function()
{
  # Creates a new level of loop scoping, on beginning a new subroutine (GOSUB).
  # Although subroutines use the same variables as the rest of the program (all
  # BASIC variables being global), a subroutine only sees the loops that were
  # created within it.
  a <- GetAllLoops()
  SetAllLoops(append(a, list(list())))
}

################################################################################
# Run-time retrieval of line numbers and BASIC program statements.

GetFileLineNumber <- function()
{
  # Returns the source file line number of the current BASIC line. For example,
  # if the current BASIC line reads '100 print x', and it appears on line 5 of
  # the source file, then this function returns the integer value 5, not 100.
  i <- GetLineIndex()
  n <- GetFileLineNumbers()
  if ((i < 1L) || (i > length(n))) return(NA_integer_)
  n[i]
}

GetFileLineNumbers <- function()
{
  # Returns a vector of all source-file line numbers for those source-file lines
  # containing an executable BASIC line (as opposed to a comment or whitespace).
  GetPro(fileLineNumbers, integer())
}

GetLineNumber <- function()
{
  # Returns the BASIC line number of the current program line.
  i <- GetLineIndex()
  n <- GetLineNumbers()
  if ((i < 1L) || (i > length(n))) return(NA_integer_)
  n[i]
}

GetLineNumbers <- function()
{
  # Returns the BASIC line numbers for every line of the entire program.
  GetPro(lineNumbers, integer())
}

GetStatement <- function()
{
  # Returns the current BASIC statement.
  GetStatementsOnLine()[GetStatementIndex()]
}

GetStatements <- function()
{
  # Returns the complete program listing, deconstructed to statements.
  GetPro(basicStatements, list())
}

GetStatementsOnLine <- function()
{
  # Returns a vector of all statements on the current line. This can be empty
  # when the line index lies beyond the end of the program.
  i <- GetLineIndex()
  s <- GetStatements()
  if ((i < 1L) || (i > length(s))) return(character())
  s[[i]]
}

################################################################################
# Low-level exit-message constructors.

ConstructLocationClause <- function()
{
  # Constructs a location clause, to be appended to an error or break message,
  # when that error or break occurred in run-time (on a specific program line).
  if (!WithinProgram()) return("")
  n <- GetLineNumber()
  if (!is.na(n)) return(paste(" on line", n))
  paste(" on file line", GetFileLineNumber())
}

EmbellishBreakMessage <- function(m)
{
  # Formats message m as a break message with line number (if applicable).
  paste0(m, ConstructLocationClause())
}

EmbellishErrorMessage <- function(m)
{
  # Formats message m as an error message with line number (if applicable).
  paste0("? ", m, " Error", ConstructLocationClause())
}

GetExitMessage <- function()
{
  # Returns the exit message as a character string (or empty character vector
  # when no message has been set).
  Value(GetExitTrigger())
}

GetExitTrigger <- function()
{
  # Returns the exit message as a BASIC break or error object (or as a BASIC
  # string, if no exit has been triggered).
  GetPro(exitTrigger, AsString(character()))
}

SetExitTrigger <- function(m)
{
  # Sets the exit trigger condition to BASIC (break or error) data object m.
  # This will overwrite any pre-existing condition.
  SetPro(exitTrigger, m)
}

SetIfNoExitTriggered <- function(m)
{
  # Sets the exit-trigger to BASIC (break or error) object m, unless some other
  # exit message already exists (in which case, no action is taken). Returns the
  # original exit trigger condition.
  if (Running()) SetExitTrigger(m)
  GetExitTrigger()
}

################################################################################
# High-level exit-message constructors.

SetBreakMessage <- function()
{
  # Thrown by a BASIC STOP command. Will not replace any pre-existing message.
  # Returns the original exit trigger condition.
  SetIfNoExitTriggered(AsBreak(EmbellishBreakMessage("Break")))
}

SetEndMessage <- function()
{
  # Thrown by a BASIC END command (for a silent exit). Will not replace any
  # pre-existing message. Returns the original exit trigger condition.
  SetIfNoExitTriggered(AsBreak(""))
}

SetErrorMessage <- function(m)
{
  # Sets the exit message to an error based on character string m, but will not
  # overwrite an existing message. Returns the original exit trigger condition.
  SetIfNoExitTriggered(AsError(EmbellishErrorMessage(m)))
}

################################################################################
# Higher-level error message constructors.

SetBadSubscriptError <- function()
{
  # Raised when an index to an array lies outside its allowed range.
  SetErrorMessage("Bad Subscript")
}

SetDivisionByZeroError <- function()
{
  # Raised when attempting to divide something by zero.
  SetErrorMessage("Division By Zero")
}

SetDuplicatedParameterError <- function()
{
  # Raised when defining a function of the same parameter twice, e.g., f(x,x).
  SetErrorMessage("Duplicated Parameter")
}

SetFileNotFoundError <- function()
{
  # Raised when attempting to access a file that cannot be read.
  SetErrorMessage("File Not Found")
}

SetIllegalQuantityError <- function()
{
  # Raised when a numerical argument to a function lies outside its permitted
  # range (such as when attempting to take the logarithm of a negative value).
  SetErrorMessage("Illegal Quantity")
}

SetLineOutOfSequenceError <- function()
{
  # Raised when the program listing contains BASIC line numbers that are not
  # monotonically increasing.
  SetErrorMessage("Line Out of Sequence")
}

SetNextWithoutForError <- function()
{
  # Raised when the program encounters an end-of-loop (NEXT), without having
  # begun the loop (without the corresponding FOR).
  SetErrorMessage("Next Without For")
}

SetOutOfDataError <- function()
{
  # Raised on an attempt to READ inline DATA, without there being any left in
  # the queue.
  SetErrorMessage("Out Of Data")
}

SetRedefinedLineError <- function()
{
  # Raised when the program listing contains a duplicated BASIC line number.
  SetErrorMessage("Redefined Line")
}

SetRedimmedArrayError <- function()
{
  # Raised when attempting to DIM an array that has already been DIMmed (even
  # when the new and old dimensions are identical).
  SetErrorMessage("Redimmed Array")
}

SetReturnWithoutGosubError <- function()
{
  # Raised upon meeting an end-of-subroutine (RETURN), without being in one
  # (without the corresponding GOSUB).
  SetErrorMessage("Return Without Gosub")
}

SetSyntaxError <- function()
{
  # Raised when a program statement breaks some or other BASIC syntax rule.
  SetErrorMessage("Syntax")
}

SetTypeMismatchError <- function()
{
  # Raised when a string (or number) was required, but a number (or string) was
  # given.
  SetErrorMessage("Type Mismatch")
}

SetUndefinedFunctionError <- function()
{
  # Raised on attempting to call a user function (FN) without first having
  # defined it (with DEF FN).
  SetErrorMessage("Undefined Function")
}

SetUndefinedStatementError <- function()
{
  # Raised on attempting to GOTO or GOSUB a BASIC line number that does not
  # appear within the program. This includes when attempting to GOTO/GOSUB to
  # a character string, variable, floating-point number, or any other token(s)
  # besides an unquoted literal string of digits.
  SetErrorMessage("Undefined Statement")
}

################################################################################
# Statement checking (for development purposes, only).

AllChecked <- function()
{
  # Returns TRUE when every last statement of the program has been executed
  # successfully at some point. Returns FALSE otherwise.
  (length(UncheckedLineIndices()) == 0L)
}

GenerateUncheckedList <- function()
{
  # Creates a list of 'unchecked' flags, one for each program statement.
  lapply(GetStatements(), function(x) rep(FALSE, length(x)))
}

GetChecks <- function()
{
  # Returns the full list of check-state flags.
  GetPro(checkedStatements, list())
}

MarkStatementsAsUnchecked <- function()
{
  # Flags all program statements as being unchecked.
  SetChecks(GenerateUncheckedList())
}

MarkStatementAsChecked <- function()
{
  # Flags the current statement as being checked. That is, as having been
  # successfully executed by the interpreter (in its entirety, without error).
  s <- GetChecks()
  s[[GetLineIndex()]][GetStatementIndex()] <- TRUE
  SetChecks(s)
}

SetChecks <- function(s)
{
  # Stores check-list s in program memory.
  SetPro(checkedStatements, s)
}

UncheckedFileLineNumbers <- function()
{
  # Returns the source-file line numbers of the unchecked statements.
  GetFileLineNumbers()[UncheckedLineIndices()]
}

UncheckedLineIndices <- function()
{
  # Returns the indices of any BASIC program lines containing at least one
  # unchecked statement.
  which(!sapply(GetChecks(), all))
}

UncheckedLineNumbers <- function()
{
  # Returns the BASIC program line numbers of the unchecked statements.
  GetLineNumbers()[UncheckedLineIndices()]
}

UncheckedLines <- function()
{
  # Returns a listing of the unchecked (not wholly checked) program lines.
  p <- ProgramListing()
  p[LineHasStatement(p)][UncheckedLineIndices()]
}

################################################################################
# Print-buffer management.

AnythingInPrintBuffer <- function()
{
  # Returns TRUE when the print buffer contains at least one character.
  # Returns FALSE otherwise.
  any(nzchar(GetPrintBuffer()))
}

AppendToPrintBuffer <- function(s)
{
  # Appends character string s to the print buffer. If s contains a newline or
  # carriage return, the buffer is printed up to (including) that character.
  # If the buffer is too large for the console, lines are printed until the
  # remainder fits.
  s <- as.character(s)
  if (!nzchar(s)) return(NULL)
  i <- gregexpr("[\n\r]", s)[[1L]][1L]
  while (i > 0L)
  {
    SetPrintBuffer(append(GetPrintBuffer(), substring(s, 0L, i - 1L)))
    ReducePrintBuffer()
    PrintPrintBuffer()
    if (substring(s, i, i) == "\n") PrintNewLine() else PrintCarriageReturn()
    s <- substring(s, i + 1L)
    i <- gregexpr("[\n\r]", s)[[1L]][1L]
  }
  SetPrintBuffer(append(GetPrintBuffer(), s))
  ReducePrintBuffer()
}

CharactersInPrintBuffer <- function()
{
  # Returns the number of characters, printable or otherwise, in the buffer.
  sum(nchar(GetPrintBuffer()))
}

ClearPrintBuffer <- function()
{
  # Empties the print buffer, leaving nothing to be printed.
  SetPro(printBuffer, "")
}

GetPrintBuffer <- function()
{
  # Retrieves the print buffer; a character vector of strings to be printed.
  GetPro(printBuffer, "")
}

ReducePrintBuffer <- function()
{
  # When printing of the buffer would extend beyond the width of the console, we
  # print however much fits and then begin a new line.
  w <- TerminalWidth()
  while(VirtualCursorPosition() > w)
  {
    n <- w - GetCursorPosition()
    s <- paste0(GetPrintBuffer(), collapse = "")
    Print(substring(s, 1L, n))
    PrintNewLine()
    SetPrintBuffer(substring(s, n + 1L))
  }
}

SetPrintBuffer <- function(s)
{
  # Sets the print buffer to character vector s.
  SetPro(printBuffer, s)
}

TerminalWidth <- function()
{
  # Returns the width of the virtual BASIC terminal, in characters. This is one
  # character less than that of the parent terminal in which it is running.
  # The reason for this, is that some terminals wrap text automatically and some
  # of those insert blank lines after printing against the right-hand margin.
  getOption("width", 73L) - 1L
}

################################################################################
# Cursor position.

AdvanceCursorPosition <- function(n)
{
  # Moves the cursor n spaces to the right (whether or not that's on the page).
  SetCursorPosition(GetCursorPosition() + n)
}

GetCursorPosition <- function()
{
  # Returns the cursor position, that being the (zero-indexed) console column
  # from where the next chunk of printed output will begin. Not accurate when
  # special characters (\a, \t, etc.) have already been printed on the line.
  GetPro(cursorPosition, 0L)
}

ResetCursorPosition <- function()
{
  # Resets the cursor position to the first (zero-indexed) console column.
  SetCursorPosition(0L)
}

SetCursorPosition <- function(n)
{
  # Sets the cursor position to console column number n (zero-indexed).
  SetPro(cursorPosition, n)
}

VirtualCursorPosition <- function()
{
  # The position the cursor would have after printing the buffer without any
  # line break. Not accurate in the presence of special characters; \a, etc.
  GetCursorPosition() + CharactersInPrintBuffer()
}

################################################################################
# Overprinting and print-skipping.

GetCharactersOnLine <- function()
{
  # The character string already printed on the current line (needed in case of
  # a carriage return and subsequent TAB, SPC, or comma over-skipping).
  GetPro(printedChars, "")
}

SetCharactersOnLine <- function(s)
{
  # Sets the character string already printed on the current line.
  SetPro(printedChars, s)
}

SetNoCharactersOnLine <- function()
{
  # Sets the current line to be empty.
  SetCharactersOnLine("")
}

UpdateCharactersOnLine <- function(s)
{
  # Adds string s to the text printed on the current line, at the current cursor
  # position. Text may already extend right of the cursor, in which case some or
  # all of it is overprinted by s. Updates the cursor position accordingly.
  n <- nchar(s)
  k <- GetCursorPosition()
  p <- GetCharactersOnLine()
  u <- paste0(substring(p, 1L, k), s, substring(p, k + n + 1L))
  SetCharactersOnLine(u)
  AdvanceCursorPosition(n)
}

################################################################################
# Teletypewriter-effect controls.

CharacterPause <- function()
{
  # Returns however many seconds are to be dwelt after printing each character.
  GetPro(ttCharDelay, 0)
}

LinePause <- function()
{
  # Returns however many seconds are to be dwelt after printing each line.
  GetPro(ttLineDelay, 0)
}

SetTeletypeCharDelay <- function(m)
{
  # Sets the teletype character-pause aesthetic. The argument, m, is a delay
  # time, in milliseconds, to be dwelt after printing each character. The delay
  # is restricted to between 0 and 0.2 seconds, with zero being the default.
  # Real teletypes could manage around 10 characters per second.
  s <- if (is.numeric(m) && (length(m) == 1L) && is.finite(m)) m / 1000 else 0
  SetPro(ttCharDelay, max(0, min(s, 0.2)))
  if (s < 0) SetTeletypeLineDelay(-1)
}

SetTeletypeLineDelay <- function(m)
{
  # Sets the teletype line-pause aesthetic. The argument, m, is a delay time, in
  # milliseconds, to be dwelt after completing each line of printing. The delay
  # is limited to no more than two seconds, with zero as the default. Negative
  # values impose no delay, but flush the console after every line of printing.
  s <- if (is.numeric(m) && (length(m) == 1L) && is.finite(m)) m / 1000 else 0
  if (s == 0) s <- LinePause()
  SetPro(ttLineDelay, if (s < 0) -1 else min(s, 2))
}

SetUpperCaseOut <- function(u)
{
  # Sets the upper-case aesthetic flag. If u is anything besides TRUE, the flag
  # is set to FALSE (do not convert printed output to upper case).
  SetPro(upperCase, is.logical(u) && (length(u) == 1L) && !is.na(u) && u)
}

UpperCaseOut <- function()
{
  # Returns TRUE when printing is to be done in upper case, or FALSE otherwise.
  GetPro(upperCase, FALSE)
}

################################################################################
# Pseudorandom numbers.

GetLastRandomNumber <- function()
{
  # Returns the most recent previously generated pseudorandom number.
  GetPro(lastRandomNumber, 0)
}

GetNewRandomNumber <- function()
{
  # Generates and returns a new pseudorandom number from the standard uniform
  # distribution. Updates lastRandomNumber in case the value is wanted again.
  SetPro(lastRandomNumber, runif(1L))
}

SeedRandomNumbers <- function(n)
{
  # Seeds the pseudorandom number generator from integer n.
  # Returns a new random number, thereby updating lastRandomNumber.
  set.seed(n)
  GetNewRandomNumber()
}

################################################################################
# Run-state tests, for trapping errors and terminating execution.

Exit <- function()
{
  # Returns the exit trigger, that being a BASIC error or break object. This is
  # used to propagate the original error back up the function call stack.
  GetExitTrigger()
}

Running <- function()
{
  # Returns TRUE if and only if no exit message has been set (whether or not the
  # program-counter lies within the program). Otherwise returns FALSE.
  !exists(exitTrigger, progMemory, inherits = FALSE)
}

Terminated <- function()
{
  # Returns TRUE if and only if an exit message has been set (whether or not the
  # program-counter lies within the program). Otherwise returns FALSE.
  exists(exitTrigger, progMemory, inherits = FALSE)
}

############################################################################ EOF

# Evaluation of BASIC expressions (not containing a command keyword).
# MJL @ Titirangi, 3 August 2022.
# Last edit: 4 October 2022.

################################################################################
# BASIC functions.

functions <- c("ABS", "ASC", "ATN", "CHR$", "COS", "EXP", "INSTR", "INT",
                "LEFT$", "LEN", "LOG", "MID$", "POS", "RND", "RIGHT$", "SGN",
                "SIN", "SPC", "SQR", "STR$", "STRING$", "SYST", "TAB", "TAN",
                "TTW", "VAL")

################################################################################
# BASIC operators and their R-function implementations.

exponentiators  <- list("^" = "EvalRAISE")
arithUnaries    <- list("-" = "EvalNEGATE", "+" = "EvalIDENTITY")
multipliers     <- list("*" = "EvalMULTIPLY", "/" = "EvalDIVIDE")
integerDividers <- list("\\" = "EvalINTEGERDIVISION")
modulos         <- list("MOD" = "EvalMODULO")
adders          <- list("+" = "EvalADD", "-" = "EvalSUBTRACT")
concatenators   <- list("+" = "EvalADD")
relationals     <- list("=" = "EvalEQUAL", "<>" = "EvalNOTEQUAL",
                        "<" = "EvalLESS", ">=" = "EvalNOTLESS",
                        ">" = "EvalGREATER", "<=" = "EvalNOTGREATER")
logicalUnaries  <- list("NOT" = "EvalNOT")
logicalBinaries <- list("AND" = "EvalAND", "OR" = "EvalOR", "XOR" = "EvalXOR")

################################################################################
# Derived vectors of operator groups (names or symbols only).

# All logical operators: NOT, AND, OR, XOR.
logicals <- c(names(logicalUnaries),
              names(logicalBinaries))

# All symbolic operators: ^, -, *, \, <>, etc.
operators <- c(names(exponentiators), names(multipliers),
               names(integerDividers), names(adders), names(relationals))

# All operators applicable to character strings: +, =, <, etc.
stringOps <- c(names(concatenators), names(relationals))

# All alphabetic operators: MOD, NOT, AND, OR, XOR.
operatorWords <- c(names(modulos), logicals)

# All binary operators: ^, MOD, +, =, <=, AND, etc.
binaries <- c(operators, names(modulos), names(logicalBinaries))

################################################################################
# BASIC digits (includes .), for detecting numeric literals.

digits <- c(as.character(seq(0L, 9L)), ".")

################################################################################
# Top-level evaluators.

Eval <- function(s)
{
  # Evaluates the BASIC expression supplied in non-empty R character string s.
  if (Terminated()) return(Exit())
  if (IsEvaluated(s)) return(as.list(s))
  a <- list()
  while (nzchar(s))
  {
    p <- EvalFirstTerm(s)
    a <- append(a, p[-length(p)])
    s <- unname(p[[length(p)]])
  }
  if (IsUnevaluated(a)) a <- EvalUnaryGroups(a) else return(a)
  if (IsUnevaluated(a)) a <- ApplyBinaryOperators(a) else return(a)
  if (IsUnevaluated(a)) SetSyntaxError() else a
}

EvalFirstTerm <- function(s)
{
  # Delegates the evaluation of the BASIC expression in string s to a handler
  # specific to the leading (left-most) term in that expression. Returns the
  # result of evaluating that first term in a list along with any remaining
  # unevaluated portion of the expression. The SPC() and TAB() functions are
  # only permitted within PRINT statements (which is not here).
  if (BeginsWithAny(c("SPC", "TAB"), s)) return(SetSyntaxError())
  if (BeginsWithAny(LETTERS, s)) return(EvalName(s))
  if (BeginsWithAny(digits, s)) return(EvalNumber(s))
  if (BeginsWithAny(operators, s)) return(IsolateOperator(s))
  if (BeginsWith("(", s)) return(EvalGroup(s))
  if (BeginsWith("\"", s)) return(EvalString(s))
  Interrupt(SetSyntaxError())
}

################################################################################
# Component-specific evaluators.

EvalArguments <- function(s)
{
  # Evaluates each expression in a comma-separated list supplied as a single
  # string s. Returns a shallow list; list(basicN = 1, basicS = "A", ...).
  EvalExpressions(SplitArguments(s))
}

EvalExpressions <- function(x)
{
  # Evaluates each expression (string) in character vector x. This produces a
  # shallow list, list(basicN = 1, basicS = "A", ...), as opposed to the deep
  # lists from lapply; list(list(basicN = 1), list(basicS = "A"), ...). We use
  # append, rather than assigning to x[i], as append migrates names from Eval(a)
  # to x (i.e., from list members to the list itself), avoiding the need to
  # follow with names(x) <- sapply(x, names); lapply(x, unname).
  v <- list()
  for (a in x) v <- append(v, as.list(Eval(a)))
  v
}

EvalFunction <- function(s)
{
  # Evaluates the BASIC function at the beginning of expression s.
  f <- BeginsWithWhich(functions, s)
  i <- PositionOfClosingParenthesis(s <- Trim(s, f))
  a <- EvalArguments(substring(s, 2L, i - 1L))
  f <- paste0("Eval", toupper(sub("$", "_", f, fixed = TRUE)))
  Intermediate(eval(call(f, a)), substring(s, i + 1L))
}

EvalGroup <- function(s)
{
  # Evaluates the parenthesis-enclosed expression at the beginning of string s.
  i <- PositionOfClosingParenthesis(s)
  if (i < 1L) return(Interrupt(SetSyntaxError()))
  g <- substring(s, 2L, i - 1L)
  if (!nzchar(g)) return(Interrupt(SetSyntaxError()))
  Intermediate(Eval(g), substring(s, i + 1L))
}

EvalName <- function(s)
{
  # Evaluates the alphanumerically named object at the beginning of statement s.
  # This might be a variable, a function, or an operator word.
  if (BeginsWith("FN", s)) return(EvalUserFunction(s))
  if (BeginsWithAny(operatorWords, s)) return(IsolateOperatorWord(s))
  # TAND is excluded here, so as to be read as T AND, rather than TAN D.
  if (BeginsWithAny(functions, s) && !BeginsWith("TAND", s))
    return(EvalFunction(s))
  v <- DetachLeadingVariable(s)
  Intermediate(GetValue(v[[variable]]), v[[remainder]])
}

EvalNumber <- function(s)
{
  # Evaluates the character-representation integer or floating point number at
  # the beginning of string s to a numeric data type. In BASIC, spaces are
  # allowed anywhere (these will have been removed), parentheses are not allowed
  # anywhere, and E can only be followed by an (optional, signed) integer (read
  # as 0 in its absence). The actual conversion is done by StringToNumber().
  i <- attr(regexpr("^[[:digit:]]*[.]{0,1}[[:digit:]]*", s), "match.length")
  if (i >= nchar(s)) return(Intermediate(AsNumber(StringToNumber(s)), ""))
  a <- substring(s, i + 1L)
  j <- attr(regexpr("^[eE][+-]{0,1}[[:digit:]]*", a), "match.length")
  if (j > 0L) {i <- i + j; a <- substring(a, j + 1L)}
  Intermediate(AsNumber(StringToNumber(substr(s, 1L, i))), a)
}

EvalString <- function(s)
{
  # Evaluates the BASIC string literal at the beginning of expression string s.
  # (Removes the enclosing quotes.)
  i <- gregexpr("\"", s, fixed = TRUE)[[1L]]
  if (length(i) < 2L) return(Intermediate(AsString(substring(s, 2L)), ""))
  Intermediate(AsString(substring(s, 2L, i[2L] - 1L)), substring(s, i[2L] + 1L))
}

EvalSubscripts <- function(s)
{
  # Evaluates a vector of BASIC array-variable subscripts, s, to R integers, for
  # value getting and setting in heap memory. The subscripts might already be
  # evaluated, or they might be character strings of unevaluated expressions.
  if (is.integer(s)) return(s)
  if (length(s) < 1L) return(integer())
  i <- EvalExpressions(s)
  if (any(Type(i) != basicN)) return(SetTypeMismatchError())
  i <- as.integer(floor(sapply(i, Value)))
  if (any(i < 0L)) return(SetIllegalQuantityError())
  i
}

EvalUnaryGroups <- function(a)
{
  # Evaluates the (implied) groups over which unary operations +, -, and NOT
  # extend, before applying the unary operation to the result. For simplicity,
  # evaluation is performed right to left. Order of precedence is preserved,
  # with unary + applying only to the immediately adjacent element, unary -
  # extending as far as the next operator besides ^ (at position j), and unary
  # NOT extending as far as the first logical binary operator (at position k).
  j <- length(a) + 1L
  k <- length(a) + 1L
  o <- rev(which(Type(a) == basicO))
  for (i in o)
  {
    n <- Value(a[i])
    # When the operator is a unary NOT, evaluate its group, then apply the NOT.
    # With right to left evaluation, groups cannot contain any unary operators,
    # so we need only apply any binaries.
    if (n == "NOT")
    {
      if (k - i < 2L) return(SetSyntaxError())
      b <- ApplyBinaryOperators(a[seq(i + 1L, k - 1L)])
      a <- append(a[-seq(i, k - 1L)], EvalNOT(b), after = i - 1L)
      k <- i + 1L
      j <- k
      next
    }
    # Unary + and - are distinguishable from their binary counterparts by their
    # immediately following either another operator, or nothing (being in the
    # first position). Unary + isn't quite the same as doing nothing, since it
    # raises an error if its operand isn't a number or string.
    if (IsUnevaluated(a[i - 1L]))
    {
      if (n == "-")
      {
        if (j - i < 2L) return(SetSyntaxError())
        b <- ApplyBinaryOperators(a[seq(i + 1L, j - 1L)])
        a <- append(a[-seq(i, j - 1L)], EvalNEGATE(b), after = i - 1L)
        k <- k - j + i + 1L
        j <- i + 1L
        next
      }
      if (n == "+")
      {
        a <- append(a[-c(i, i + 1L)], EvalIDENTITY(a[i + 1L]), after = i - 1L)
        j <- j - 1L
        k <- k - 1L
        next
      }
    }
    # When the operator is binary, reassess the end-points of the extent of any
    # subsequent (leftward) arithmetical (j) or logical (k) unary operators.
    if (n != "^")
    {
      j <- i
      if (any(n == logicals)) k <- i
    }
  }
  a
}

EvalUserFunction <- function(s)
{
  # Evaluates the user-defined BASIC function at the beginning of string s.
  # Note that function parameters, as in f[["parameters"]], are stored as names
  # of the underlying heap-memory R storage-objects, and not as BASIC variables.
  a <- DetachLeadingVariable(Trim(s, "FN"))
  if (Terminated()) return(Interrupt(Exit()))
  v <- a[[variable]]
  n <- paste0(substring(s, 1L, 2L), NameOfVariable(v))
  y <- TypeFromName(n)
  f <- RecallFunction(n)
  p <- f[["parameters"]]
  u <- EvalExpressions(SubscriptsOfVariable(v))
  if (!ArgsMatch(TypeFromName(p), u)) return(Interrupt(Exit()))
  z <- list()
  for (i in seq_along(p))
  {
    w <- if (ObjectExists(p[i])) GetObject(p[i]) else InitialDatum(p[i])
    z <- append(z, list(w))
    v <- if (IsIntegerConstrained(p[i])) floor(Value(u[i])) else Value(u[i])
    SetObject(p[i], v)
  }
  x <- Eval(f[["definition"]])
  for (i in seq_along(p)) SetObject(p[i], z[[i]])
  if (Type(x) != y) return(Interrupt(SetTypeMismatchError()))
  if (IsIntegerConstrained(n)) x <- AsNumber(floor(Value(x)))
  Intermediate(x, a[[remainder]])
}

################################################################################
# Evaluation assistants.

ArgsMatch <- function(a, x)
{
  # Returns TRUE if the evaluated BASIC values in list x exactly match the types
  # named by character vector a. Raises an error and returns FALSE otherwise.
  # This function is only called after complete evaluation of all the arguments
  # in x. Hence all are of BASIC number of string type (no NULLs or operators,
  # or untyped values), otherwise an error would have been raised by Eval().
  if ((length(x) == length(a)) && all(Type(x) == a)) return(TRUE)
  if (length(x) != length(a)) SetSyntaxError() else SetTypeMismatchError()
  FALSE
}

BeginsWith <- function(w, s)
{
  # Returns TRUE where the strings of character vector s begin with word w, and
  # FALSE elsewhere. Alternatively, s can be a string and w a character vector.
  # Case insensitive.
  toupper(w) == toupper(substring(s, 1L, nchar(w)))
}

BeginsWithAny <- function(w, s)
{
  # Returns TRUE if string s begins with any of the strings in character vector
  # w. Alternatively, s can be a character vector and w a character string.
  # Case insensitive.
  any(BeginsWith(w, s))
}

BeginsWithWhich <- function(w, s)
{
  # Returns the longest string from character vector w that appears at the
  # beginning of string s (i.e., the greediest match). Case insensitive. Returns
  # an empty character vector when no string in w matches the beginning of s.
  a <- w[BeginsWith(w, s)]
  a[which.max(nchar(a))]
}

IsEvaluated <- function(x)
{
  # Returns TRUE if x is a fully evaluated BASIC value (a string or number).
  # Otherwise returns FALSE, including if x is NULL or empty.
  !IsUnevaluated(x)
}

IsFunction <- function(s)
{
  # Returns TRUE if s is the name of a BASIC function (ABS, MID$, et cetera).
  # Otherwise returns FALSE, including if s is empty or NULL.
  (length(s) == 1L) && any(functions == toupper(s), na.rm = TRUE)
}

IsolateOperator <- function(s)
{
  # Detaches an arithmetical or relational operator from the beginning of
  # statement s. The operator is not applied at this time.
  o <- BeginsWithWhich(operators, s)
  Intermediate(AsOperator(o), substring(s, nchar(o) + 1L))
}

IsolateOperatorWord <- function(s)
{
  # Detaches an operator word from the beginning of statement s.
  # The operator is not applied at this time.
  o <- BeginsWithWhich(operatorWords, s)
  Intermediate(AsOperator(o), substring(s, nchar(o) + 1L))
}

IsUnevaluated <- function(x)
{
  # Returns FALSE if x is a fully evaluated BASIC value (a string or number).
  # Otherwise returns TRUE, including if x is NULL or empty or non-singleton.
  (length(x) != 1L) || all(Type(x) != c(basicN, basicS), na.rm = TRUE)
}

Intermediate <- function(x, s)
{
  # Bundles the result, x, of evaluating part of a statement, with the remaining
  # (unevaluated) part, s (a character string), into list. While x ought to be a
  # named list, we allow for unnamed, a vector, or NULL. In general, x can be a
  # list of partial results (say, an unapplied operator followed by an evaluated
  # argument).
  if (is.null(Type(x))) x <- AsError(x)
  append(as.list(x), if (length(s) > 0L) unname(s) else "")
}

Interrupt <- function(e)
{
  # A special version of Intermediate() for when an error has occurred. Sets the
  # remaining (unevaluated) expression to the empty string, leaving nothing to
  # evaluate (ends evaluation, even if the error itself doesn't).
  Intermediate(e, "")
}

PositionOfClosingParenthesis <- function(s)
{
  # If the first character in statement s is an opening parenthesis, we return
  # the position (index) of the corresponding closing parenthesis. If that
  # closing parenthesis does not exist within s, then an error is raised and -1L
  # is returned. If the first character in s is not an opening parenthesis, then
  # 0L is returned (no error is raised in this case). While we perhaps ought to
  # check for REMs here (which would hide any parentheses to the right), we get
  # the same syntax error on attempting to evaluate the REM, anyway. In original
  # BASIC, 'MID$("ABC", "D", REM)' and 'MID$("ABC", "D"' are both type mismatch
  # errors (on the "D"), before getting to the REM or missing parenthesis, while
  # we'll get a syntax error as all arguments are evaluated before type checks.
  if (!BeginsWith("(", s)) return(0L)
  iq <- PositionsOf("\"", s)
  io <- Unenclosed("(", s, iq)
  ic <- c(0L, Unenclosed(")", s, iq))
  jc <- (sapply(lapply(ic, ">", io), sum) - seq_along(ic) + 1L)[-1L]
  if (all(jc)) {SetSyntaxError(); return(-1L)}
  ic[which.min(abs(jc)) + 1L]
}

PositionsOf <- function(w, s)
{
  # Returns all positions of word w within string s. Returns an empty vector
  # when w does not appear within s. Case sensitive.
  i <- gregexpr(w, s, fixed = TRUE)[[1L]]
  i[i > 0L]
}

SplitArguments <- function(s)
{
  # Splits a character string, s, of comma-separated (unevaluated) statements
  # into a vector of those same statements. As in PositionOfClosingParenthesis,
  # we do not check for REMs. If one is present, we'll still get a syntax error
  # when we attempt to evaluate it.
  if (!grepl(",", s, fixed = TRUE)) return(s)
  if (!grepl("[\"(]", s))
    return(c(strsplit(s, ",", fixed = TRUE)[[1L]], rep("", grepl(",$", s))))
  iq <- PositionsOf("\"", s)
  io <- Unenclosed("(", s, iq)
  ic <- Unenclosed(")", s, iq)
  id <- c(0L, Unbracketed(Unenclosed(",", s, iq), io, ic), nchar(s) + 1L)
  substring(s, id[-length(id)] + 1L, id[-1L] - 1L)
}

StringToNumber <- function(s)
{
  # Converts the character-string representation of an integer or floating point
  # number, s, to numerical type, without flagging it as being an evaluated
  # BASIC number. Neither R nor BASIC allow parentheses within the string, nor E
  # being followed by a non-integer power, nor E being the first character in
  # the string. Both allow '1E', '1E+', and '1E-' (these are all read as 1E0).
  # BASIC allows blank spaces while R does not, but these will have already been
  # removed. Unlike R, BASIC allows '.', '.E', '.E+4', etc., so we catch this as
  # a special case ('.' without digits is read as floating-point zero).
  if (grepl("^\\.(E|$)", s, ignore.case = TRUE)) return(0)
  n <- try(suppressWarnings(as.numeric(s)), silent = TRUE)
  if (!is.finite(n) || inherits(n, "try-error")) return(SetSyntaxError())
  n
}

Unbracketed <- function(x, a, b)
{
  # Returns the positions, x, along some string, that are not contained between
  # opening and closing brackets at positions a and b, respectively. Any or all
  # of these can be empty. Returns an empty vector when no unbracketed positions
  # appear within x. The 'k' in '(k' is considered to be contained (even in the
  # absence of a closing bracket).
  x[as.logical(sapply(x, function(y, i, j) sum(y > j) >= sum(y > i), a, b))]
}

Unenclosed <- function(w, s, i)
{
  # Returns all positions of word w within string s that are not inside a pair
  # of delimiting characters (or words, typically quotation marks) at positions
  # i along the same string, according to the even/odd delimiter-count rule.
  # Case sensitive. The delimiter-position vector, i, can be empty. Returns an
  # empty vector when there are no unenclosed occurrences of w within s.
  u <- PositionsOf(w, s)
  u[as.logical(sapply(u, function(a, b) sum(a > b) %% 2L == 0L, i))]
}

################################################################################
# Binary-operator applicators.

ApplyAdders <- function(a)
{
  # Applies any addition or subtraction operators appearing within the list of
  # BASIC statement components, a. Addition includes string concatenation.
  ApplyCollection(adders, a)
}

ApplyBinaryOperators <- function(a)
{
  # Applies all BASIC binary operators found within the list of (otherwise)
  # evaluated expression components, a, in order of decreasing precedence.
  # There can be no groupings or unary operators within the list.
  a <- ApplyExponentiators(a); if (IsEvaluated(a)) return(a)
  a <- ApplyMultipliers(a); if (IsEvaluated(a)) return(a)
  a <- ApplyIntegerDividers(a); if (IsEvaluated(a)) return(a)
  a <- ApplyModulos(a); if (IsEvaluated(a)) return(a)
  a <- ApplyAdders(a); if (IsEvaluated(a)) return(a)
  a <- ApplyRelationals(a); if (IsEvaluated(a)) return(a)
  ApplyLogicals(a)
}

ApplyCollection <- function(f, a)
{
  # Applies any of the members of a list of equal-precedence operators, f,
  # wherever they appear within the list of BASIC statement components, a, in
  # left-to-right order. An example of f is list("^" = "EvalRAISE").
  # The Terminated() check is necessary in case of adjacent operators.
  z <- WhichAreOperators(Type(f), a)
  for (h in seq_along(z))
  {
    j <- z[h]; i <- j - 1L; k <- j + 1L
    x <- eval(call(f[[Value(a[j])]], a[i], a[k]))
    if (Terminated()) return(SetSyntaxError())
    a <- append(a[-c(i, j, k)], x, after = i - 1L)
    z <- z - 2L
  }
  a
}

ApplyExponentiators <- function(a)
{
  # Applies any exponentiation (power) operators appearing within the list of
  # BASIC statement components, a, in left-to-right order.
  ApplyCollection(exponentiators, a)
}

ApplyIntegerDividers <- function(a)
{
  # Applies any integer-division operators appearing within the list of BASIC
  # statement components, a, in left-to-right order.
  ApplyCollection(integerDividers, a)
}

ApplyLogicals <- function(a)
{
  # Applies any binary logical operators appearing within the list of BASIC
  # statement components, a, in order of decreasing precedence.
  o <- logicalBinaries
  for (i in seq_along(o)) a <- ApplyCollection(o[i], a)
  a
}

ApplyModulos <- function(a)
{
  # Applies any modulo operators appearing within the list of BASIC statement
  # components, a, in left-to-right order.
  ApplyCollection(modulos, a)
}

ApplyMultipliers <- function(a)
{
  # Applies any multiplication or division operators appearing within the list
  # of BASIC statement components, a.
  ApplyCollection(multipliers, a)
}

ApplyRelationals <- function(a)
{
  # Applies any relational operators appearing within the list of BASIC
  # statement components, a, in left-to-right order.
  ApplyCollection(relationals, a)
}

WhichAreOperators <- function(s, a)
{
  # Returns the position indices, within the list of BASIC statement components,
  # a, of any member of the vector of operator symbols, s.
  i <- which(Type(a) == basicO)
  i[as.character(a[i]) %in% s]
}

################################################################################
# BASIC function evaluators.

EvalABS <- function(x)
{
  # Returns the absolute value of the BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(abs(Value(x)))
}

EvalASC <- function(x)
{
  # Returns the ASCII code of the first character of the BASIC string x.
  if (!ArgsMatch(basicS, x)) return(Exit())
  if (!nzchar(Value(x))) return(SetIllegalQuantityError())
  AsNumber(utf8ToInt(substring(Value(x), 1L, 1L)))
}

EvalATN <- function(x)
{
  # Returns the arctangent of the BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(atan(Value(x)))
}

EvalCHR_ <- function(x)
{
  # Returns the ASCII character whose code is the greatest integer not greater
  # than the BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  if (Value(x) < 0) return(SetIllegalQuantityError())
  AsString(intToUtf8(as.integer(floor(Value(x)))))
}

EvalCOS <- function(x)
{
  # Returns the cosine of the BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(cos(Value(x)))
}

EvalEXP <- function(x)
{
  # Returns the exponential of the BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(exp(Value(x)))
}

EvalINSTR <- function(x)
{
  # Locates one string within another. List x contains two or three arguments:
  # integer N, string S, and word W, with N being optional (defaults to unity).
  # Returns the position of the first (case-insensitive) occurrence of W within
  # S not before the Nth character. Returns zero when S is empty, or has fewer
  # than N characters, or when W does not appear within S at or after the Nth
  # character. W can be the empty string (matches at N).
  if (length(x) == 2L) x <- append(AsNumber(1), x)
  if (!ArgsMatch(c(basicN, basicS, basicS), x)) return(Exit())
  i <- max(1L, as.integer(floor(x[[1L]])))
  if (i > nchar(x[[2L]])) return(AsNumber(0))
  j <- regexpr(toupper(x[[3L]]), toupper(substring(x[[2L]], i)), fixed = TRUE)
  if (j < 1L) return(AsNumber(0))
  AsNumber(i + j - 1L)
}

EvalINT <- function(x)
{
  # Returns the greatest integer not greater than the BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(floor(Value(x)))
}

EvalLEFT_ <- function(x)
{
  # Returns the leftmost x[2] characters of BASIC string x[1], or the whole of
  # x[1] if it has fewer than x[2] characters.
  if (!ArgsMatch(c(basicS, basicN), x)) return(Exit())
  if (x[[2L]] < 0) return(SetIllegalQuantityError())
  AsString(substring(x[[1L]], 0L, as.integer(floor(x[[2L]]))))
}

EvalLEN <- function(x)
{
  # Returns the number of characters in BASIC string x.
  if (!ArgsMatch(basicS, x)) return(Exit())
  AsNumber(nchar(Value(x)))
}

EvalLOG <- function(x)
{
  # Returns the natural logarithm of BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  if (Value(x) <= 0) return(SetIllegalQuantityError())
  AsNumber(log(Value(x)))
}

EvalMID_ <- function(x)
{
  # Returns x[3] characters from BASIC string x[1], beginning from the x[2]th
  # character. If x[3] is omitted, or if x[2] + x[3] exceeds the number of
  # characters in x[1], then all characters in x[1], from the x[2]th onward,
  # are returned. If x[2] exceeds the number of characters in x[1], then an
  # empty string is returned.
  if (!ArgsMatch(c(basicS, basicN, basicN)[-length(x) - 1L], x)) return(Exit())
  if ((x[[2L]] < 1) || (x[[length(x)]] < 0)) return(SetIllegalQuantityError())
  i <- as.integer(floor(x[[2L]]))
  j <- if (length(x) == 3L) as.integer(floor(x[[3L]])) else nchar(x[[1L]])
  AsString(substring(x[[1L]], i, i + j - 1L))
}

EvalPOS <- function(x)
{
  # Returns the (virtual) cursor position from the left margin, starting from 0.
  # Not accurate when special characters are on the line (\a, \t, et cetera).
  if (!ArgsMatch(basicN, x)) return(Exit())
  if (!any(Value(x) == c(0, 1))) return(SetIllegalQuantityError())
  AsNumber(VirtualCursorPosition())
}

EvalRND <- function(x)
{
  # Returns a pseudo-random variate from the uniform distribution over (0, 1).
  # When x is zero, the previous value is returned (rather than a new one).
  # When x is negative, the generator is seeded with as.integer(floor(x)).
  if (!ArgsMatch(basicN, x)) return(Exit())
  v <- Value(x)
  if (v > 0) return(AsNumber(GetNewRandomNumber()))
  if (v == 0) return(AsNumber(GetLastRandomNumber()))
  AsNumber(SeedRandomNumbers(as.integer(floor(v))))
}

EvalRIGHT_ <- function(x)
{
  # Returns the rightmost x[2] characters of BASIC string x[1], or the whole of
  # x[1] if it has fewer than x[2] characters.
  if (!ArgsMatch(c(basicS, basicN), x)) return(Exit())
  if (x[[2L]] < 0) return(SetIllegalQuantityError())
  n <- nchar(x[[1L]])
  AsString(substring(x[[1L]], n - as.integer(floor(x[[2L]])) + 1L, n))
}

EvalSGN <- function(x)
{
  # Returns the signum function of BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(sign(Value(x)))
}

EvalSIN <- function(x)
{
  # Returns the sine of BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(sin(Value(x)))
}

EvalSPC <- function(x)
{
  # Rapidly moves the cursor x spaces to the right or left, wrapping at the
  # width of the console (which may trigger one or more newlines). Wrapping may
  # be inaccurate when special characters (\t, etc.) are present on the line.
  if (!ArgsMatch(basicN, x)) return(Exit())
  n <- as.integer(floor(Value(x)))
  if (n < 0L) {RetractPrintHead(-n); return(AsOperator(";"))}
  k <- VirtualCursorPosition()
  w <- TerminalWidth()
  m <- (k + n) - w
  if (m > 0L) {PrintBufferAndNewline(); n <- m}
  while (n > w) {PrintNewLine(); n <- n - w}
  AdvancePrintHead(n)
  AsOperator(";")
}

EvalSQR <- function(x)
{
  # Returns the square root of BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  if (Value(x) < 0) return(SetIllegalQuantityError())
  AsNumber(sqrt(Value(x)))
}

EvalSTR_ <- function(x)
{
  # Returns a character-string representation of BASIC number x.
  # Non-negative values acquire a leading space.
  if (!ArgsMatch(basicN, x)) return(Exit())
  v <- Value(x)
  s <- toupper(format(v, digits = printPrecision, decimal.mark = "."))
  s <- sub("0.", ".", s, fixed = TRUE)
  if (v >= 0) s <- paste0(" ", s)
  AsString(s)
}

EvalSTRING_ <- function(x)
{
  # Returns a BASIC string consisting of x[1] copies of string x[2] (or spaces,
  # if x[2] is omitted).
  if (!ArgsMatch(c(basicN, basicS)[-length(x) - 1L], x)) return(Exit())
  n <- as.integer(floor(x[[1L]]))
  if (n < 0L) return(SetIllegalQuantityError())
  AsString(strrep(if (length(x) == 2L) x[[2L]] else " ", n))
}

EvalSYST <- function(x)
{
  # Returns the current system date-time, in seconds.
  if (!ArgsMatch(basicN, x)) return(Exit())
  if (!any(Value(x) == c(0, 1))) return(SetIllegalQuantityError())
  AsNumber(Sys.time())
}

EvalTAB <- function(x)
{
  # Positions the cursor such that the next character will be printed in column
  # x. We extend to allow negative values to mean -x spaces from the right-hand
  # margin. No action is performed when the cursor already lies at or beyond the
  # requested position. Positioning will be inaccurate when special characters
  # (\a, \b, \t, etc.) have been placed on the line.
  if (!ArgsMatch(basicN, x)) return(Exit())
  p <- as.integer(floor(Value(x))) %% TerminalWidth()
  k <- VirtualCursorPosition()
  if (p > k) AdvancePrintHead(p - k)
  AsOperator(";")
}

EvalTAN <- function(x)
{
  # Returns the tangent of BASIC number x.
  if (!ArgsMatch(basicN, x)) return(Exit())
  AsNumber(tan(Value(x)))
}

EvalTTW <- function(x)
{
  # Returns the current width of the terminal, as a number of characters.
  if (!ArgsMatch(basicN, x)) return(Exit())
  if (!any(Value(x) == c(0, 1))) return(SetIllegalQuantityError())
  AsNumber(TerminalWidth())
}

EvalVAL <- function(x)
{
  # Treats BASIC string x as the character representation of a numerical value,
  # and returns the corresponding BASIC number. When x cannot be identified as
  # a number, BASIC 0 is returned (no error is raised).
  if (!ArgsMatch(basicS, x)) return(Exit())
  s <- gsub("[[:blank:]]+", "", Value(x))
  n <- try(suppressWarnings(as.numeric(s)), silent = TRUE)
  if (!is.finite(n) || inherits(n, "try-error")) return(AsNumber(0))
  AsNumber(n)
}

################################################################################
# Arithmetical operations.

EvalADD <- function(x, y)
{
  # Applies the addition operator between two BASIC numbers or two BASIC strings
  # (performs concatenation), x and y.
  if (IsString(x) && IsString(y)) return(AsString(paste0(Value(x), Value(y))))
  if (IsNumber(x) && IsNumber(y)) return(AsNumber(Value(x) + Value(y)))
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  SetTypeMismatchError()
}

EvalDIVIDE <- function(x, y)
{
  # Applies the division operator between two BASIC numbers, x (the dividend)
  # and y (the divisor).
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (!IsNumber(x) || !IsNumber(y)) return(SetTypeMismatchError())
  if (Value(y) == 0) return(SetDivisionByZeroError())
  AsNumber(Value(x) / Value(y))
}

EvalIDENTITY <- function(x)
{
  # Applies the unary identity operation to a BASIC string or number, x.
  # This function is only called after x has been fully evaluated. BASIC allows
  # this operation upon strings (e.g., +"A"). Expressions such as '3+' and '+'
  # are not allowed; the operator must still act on a valid data value.
  if (IsUnevaluated(x)) return(SetSyntaxError())
  x
}

EvalINTEGERDIVISION <- function(x, y)
{
  # Applies the integer-division operator between two BASIC numbers, x (the
  # dividend) and y (the divisor). As in original (extended) Altair BASIC, both
  # operands are truncated to integers before the operation, and the result is
  # rounded toward zero.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (!IsNumber(x) || !IsNumber(y)) return(SetTypeMismatchError())
  a <- floor(Value(x))
  b <- floor(Value(y))
  if (b == 0) return(SetDivisionByZeroError())
  v <- a / b
  AsNumber(sign(v) * floor(abs(v)))
}

EvalMODULO <- function(x, y)
{
  # Applies the modulo operator between two BASIC numbers, x (the dividend) and
  # y (the modulus). As in original (extended) Altair BASIC, the operation is
  # defined as A MOD B = A - B * (A\B), with both operands being truncated to
  # integers beforehand.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (!IsNumber(x) || !IsNumber(y)) return(SetTypeMismatchError())
  a <- floor(Value(x))
  b <- floor(Value(y))
  if (b == 0) return(SetDivisionByZeroError())
  v <- a / b
  AsNumber(a - b * sign(v) * floor(abs(v)))
}

EvalMULTIPLY <- function(x, y)
{
  # Applies the multiplication operator between two BASIC numbers, x and y.
  if (IsNumber(x) && IsNumber(y)) return(AsNumber(Value(x) * Value(y)))
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  SetTypeMismatchError()
}

EvalNEGATE <- function(x)
{
  # Applies the unary negation operator to a BASIC number, x.
  # This function is only called after x has been fully evaluated.
  # BASIC does not allow negation of strings.
  if (IsNumber(x)) return(AsNumber(-Value(x)))
  if (IsUnevaluated(x)) return(SetSyntaxError())
  SetTypeMismatchError()
}

EvalRAISE <- function(x, y)
{
  # Applies the exponentiation operator between two BASIC numbers, x (the base)
  # and y (the power).
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (!IsNumber(x) || !IsNumber(y)) return(SetTypeMismatchError())
  a <- Value(x); b <- Value(y)
  if ((a < 0) && (b != floor(b))) return(SetIllegalQuantityError())
  if ((a == 0) && (b < 0)) return(SetDivisionByZeroError())
  AsNumber(a ^ b)
}

EvalSUBTRACT <- function(x, y)
{
  # Applies the subtraction operator between two BASIC numbers, x (the
  # subtrahend) and y (the minuend).
  if (IsNumber(x) && IsNumber(y)) return(AsNumber(Value(x) - Value(y)))
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  SetTypeMismatchError()
}

################################################################################
# Relational operations.

EvalEQUAL <- function(x, y)
{
  # Returns BASIC -1 (true) if BASIC value x equals BASIC value y.
  # Otherwise, returns BASIC 0 (false). String comparisons are case-insensitive.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (Type(x) != Type(y)) return(SetTypeMismatchError())
  AsNumber(-as.numeric(Caseless(x) == Caseless(y)))
}

EvalGREATER <- function(x, y)
{
  # Returns BASIC -1 (true) if BASIC value x is greater than BASIC value y.
  # Otherwise, returns BASIC 0 (false). String comparisons are case-insensitive.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (Type(x) != Type(y)) return(SetTypeMismatchError())
  AsNumber(-as.numeric(Caseless(x) > Caseless(y)))
}

EvalLESS <- function(x, y)
{
  # Returns BASIC -1 (true) if BASIC value x is less than BASIC value y.
  # Otherwise, returns BASIC 0 (false). String comparisons are case-insensitive.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (Type(x) != Type(y)) return(SetTypeMismatchError())
  AsNumber(-as.numeric(Caseless(x) < Caseless(y)))
}

EvalNOTEQUAL <- function(x, y)
{
  # Returns BASIC -1 (true) if BASIC value x does not equal BASIC value y.
  # Otherwise, returns BASIC 0 (false). String comparisons are case-insensitive.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (Type(x) != Type(y)) return(SetTypeMismatchError())
  AsNumber(-as.numeric(Caseless(x) != Caseless(y)))
}

EvalNOTGREATER <- function(x, y)
{
  # Returns BASIC -1 (true) if BASIC value x is less than or equal to BASIC
  # value y. Otherwise, returns BASIC 0 (false).
  # String comparisons are case-insensitive.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (Type(x) != Type(y)) return(SetTypeMismatchError())
  AsNumber(-as.numeric(Caseless(x) <= Caseless(y)))
}

EvalNOTLESS <- function(x, y)
{
  # Returns BASIC -1 (true) if BASIC value x is greater than or equal to BASIC
  # value y. Otherwise, returns BASIC 0 (false).
  # String comparisons are case-insensitive.
  if (IsUnevaluated(x) || IsUnevaluated(y)) return(SetSyntaxError())
  if (Type(x) != Type(y)) return(SetTypeMismatchError())
  AsNumber(-as.numeric(Caseless(x) >= Caseless(y)))
}

################################################################################
# Logical bitwise operations.

EvalAND <- function(a, b)
{
  # Performs bitwise logical AND on BASIC numbers a and b, after coercing both
  # to integer format.
  if (IsNumber(a) && IsNumber(b))
    return(AsNumber(bitwAnd(as.integer(Value(a)), as.integer(Value(b)))))
  if (IsUnevaluated(a) || IsUnevaluated(b)) return(SetSyntaxError())
  SetTypeMismatchError()
}

EvalNOT <- function(a)
{
  # Performs bitwise logical NOT on BASIC number a, after coercing it to integer
  # format. Within this format, NOT A = -(A + 1). Hence, NOT NOT A = A,
  # NOT 0 = -1, and NOT -1 = 0, consistent with BASIC's false = 0, true = -1.
  if (IsNumber(a)) return(AsNumber(bitwNot(as.integer(Value(a)))))
  if (IsUnevaluated(a)) return(SetSyntaxError())
  SetTypeMismatchError()
}

EvalOR <- function(a, b)
{
  # Performs bitwise logical OR on BASIC numbers a and b, after coercing both
  # to integer format.
  if (IsNumber(a) && IsNumber(b))
    return(AsNumber(bitwOr(as.integer(Value(a)), as.integer(Value(b)))))
  if (IsUnevaluated(a) || IsUnevaluated(b)) return(SetSyntaxError())
  SetTypeMismatchError()
}

EvalXOR <- function(a, b)
{
  # Performs bitwise logical XOR on BASIC numbers a and b, after coercing both
  # to integer format.
  if (IsNumber(a) && IsNumber(b))
    return(AsNumber(bitwXor(as.integer(Value(a)), as.integer(Value(b)))))
  if (IsUnevaluated(a) || IsUnevaluated(b)) return(SetSyntaxError())
  SetTypeMismatchError()
}

############################################################################ EOF

# BASIC programmer's development tools.
# MJL @ Titirangi, 11 August 2022.
# Last edit: 11 September 2022.

################################################################################
# Program listing / checking.

LIST <- function()
{
  # Lists the entire program as a character vector.
  ProgramListing()
}

NotRun <- function(pretty = TRUE)
{
  # Returns a data frame of unchecked (not wholly checked) lines, by file line
  # number and BASIC line number. If the pretty argument is TRUE, the frame is
  # returned invisibly after printing a formatted version to standard output.
  # The unchecked file line numbers, u, are monotonically increasing.
  u <- UncheckedFileLineNumbers()
  i <- UncheckedLineNumbers()
  s <- UncheckedLines()
  a <- data.frame(FileLine = u, Line = i, Listing = s)
  if (!pretty) return(a)
  n <- length(u)
  if (n == 0L) return(cat("Ok\n"))
  i <- floor(log10(u[n])) - floor(log10(u))
  cat(paste0(strrep(" ", i), "[", u, "] ", s, "\n"), sep = "")
  cat("(", n, " unchecked line", strrep("s", sign(n - 1L)), ")\n", sep = "")
  invisible(a)
}

################################################################################
# Case conversion.

ToCase <- function(p, f)
{
  # Apply function f to program listing p, excepting it's string literals.
  h <- gregexpr("\"", p, fixed = TRUE)
  for (i in seq_along(p))
  {
    j <- h[[i]]
    p[i] <- if (!any(j > 0L)) f(p[i]) else
            {
              j <- c(-1L, j[j > 0L], nchar(p[i]) + 1L)
              a <- substring(p[i], j[-length(j)], j[-1L] - 1L)
              a[c(TRUE, FALSE)] <- f(a[c(TRUE, FALSE)])
              paste0(a, collapse = "")
            }
  }
  p
}

LowerCode <- function(p)
{
  # Convert program listing p to lower case, excepting its string literals.
  ToCase(p, tolower)
}

UpperCode <- function(p)
{
  # Convert program listing p to upper case, excepting its string literals.
  ToCase(p, toupper)
}

############################################################################ EOF

\name{NotRun}
\alias{NotRun}
\title{
Check BASIC Programs
}
\description{
Returns a data frame of any \acronym{BASIC} program lines that contain one or
more unexecuted statements.
Used with repeated calls of \code{RUN()}, this provides a test of code syntax
and accessibility.
}
\usage{
NotRun(pretty = TRUE)
}
\arguments{
  \item{pretty}{
A single logical value.
If \code{TRUE} (the default), formatted output is printed before the data frame
is returned invisibly.
If \code{FALSE}, the data frame is returned normally (visibly), without any
other output being printed.
}
}
\value{
Returns a data frame of any lines, from the currently-loaded \acronym{BASIC}
program, containing one or more unexecuted statements.
Lines are listed with both their \acronym{BASIC} line numbers and the
corresponding file line numbers of the source script.
A persistent appearance here may, but does not necessarily, signify a problem
with the line.
}
\note{
\acronym{BASIC} \code{ON} and \code{IF-THEN-ELSE} statements contain multiple
alternative clauses.
Each such statement, as a whole, is marked as having been executed once any one
of its clauses has been run without error.
Hence, the absence of such a statement from the \code{NotRun()} frame does not
guarantee that all of its clauses are error-free.
}
\seealso{
\code{\link{RUN}}
}
\examples{
# Peruse which lines have not yet been run.
NotRun()
}

\name{RUN}
\alias{RUN}
\title{
Run BASIC Programs
}
\description{
Loads and runs \acronym{BASIC} programs.
}
\usage{
RUN(program = NULL, ttx = 0, tty = 0, up = FALSE)
}
\arguments{
  \item{program}{
A character string, containing the name or file path of a \acronym{BASIC}
program.
Omitting this re-runs the currently-loaded program.
}
  \item{ttx}{
Aesthetic teletype option.
A delay, of not more than 200 milliseconds, to be applied after printing each
character.
In practice, the actual delay will be this time plus however long it takes to
flush the console, plus interpreter overheads.
Depending on the model, a real teletype could manage around ten characters per
second.
Making this negative imposes no delay, but flushes the console after each
completed line (not after each character).
}
  \item{tty}{
Aesthetic teletype option.
A delay, of not more than 2000 milliseconds, to be applied after each line of
printing.
Making this negative imposes no delay, but still flushes the console after
each completed line.
}
  \item{up}{
Aesthetic teletype option.
Making this \code{TRUE} forces all \acronym{BASIC} output to upper case.
}
}
\value{
Returns an invisible \code{NULL}, after printing to standard output.
}
\details{
List of bundled example programs (from the references):
\tabular{llr}{\emph{Animal} \tab by Arthur Luehrmann \tab (decision trees)
\cr\emph{Camel} \tab by the Heath Users Group \tab (random walk)
\cr\emph{Chase} \tab by Mac Oglesby \tab (robots)
\cr\emph{Eliza} \tab by Jeff Shrager \tab (language processing)
\cr\emph{Even Wins} \tab by Eric Peters \tab (machine learning)
\cr\emph{Flip} \tab by John S.{} James \tab (machine learning)
\cr\emph{Four in a Row} \tab by James L.{} Murphy \tab (artificial intelligence)
\cr\emph{Guess-It} \tab by Gerard Kierman \tab (bluffing)
\cr\emph{Hammurabi} \tab by David H.{} Ahl \tab (resource management)
\cr\emph{Hexapawn} \tab by R.{} A.{} Kaapke \tab (machine learning)
\cr\emph{Inkblot} \tab by Scott Costello \tab (projection)
\cr\emph{Life} \tab by Clark Baker \tab (cellular automata)
\cr\emph{Maze} \tab by Richard Schaal \tab (depth-first search)
\cr\emph{Not One} \tab by Robert Puopolo \tab (expectation values)
\cr\emph{Sea Battle} \tab by Vincent Erickson \tab (monsters)
\cr\emph{Super Star Trek} \tab by Richard Leedon \tab (vector space)
\cr\emph{Wumpus} \tab by Gregory Yob \tab (graph topology)}
All of these are in the public domain.
}
\note{
Many \acronym{BASIC} programs ask for user input after printing a custom prompt.
When \code{ttx} is greater than zero, some \R sessions may incorrectly position
the cursor at the beginning of the line, or on the next.
Neither occurrence is fatal.
Known to be affected: Windows \R terminal (\file{R} and \file{Rterm}, but the
\file{Rgui} console is fine), Mac \R console (but the Bash terminal is fine),
RStudio.
Additionally, double buffering, or the like, may interfere with the effect at
higher speeds (Mac \R console, again).
}
\references{
\enumerate{
\item David H.{} Ahl & Steve North, \emph{BASIC Computer Games} (1978)
\item David H.{} Ahl & Steve North, \emph{More BASIC Computer Games} (1979)
}
}
\seealso{
\code{\link{LIST}}
}
\examples{
\dontrun{
# Load and run 'Wumpus'.
RUN("wumpus")

# Load and run 'Chase', flushing the
# console after every line of output.
RUN("chase", -1)

# Load and run 'Camel', with full
# retro-style teletypewriter effects.
RUN("camel", 20, 300, TRUE)

# Load and run your program.
RUN("myprogram.bas")

# Re-run the last program
# (without re-loading it).
RUN()
}
}

\name{LIST}
\alias{LIST}
\title{
List BASIC Programs
}
\description{
Lists whichever \acronym{BASIC} program is loaded.
}
\usage{
LIST()
}
\value{
Returns a character vector, containing the complete listing of whichever
\acronym{BASIC} program is in memory at the time.
}
\seealso{
\code{\link{NotRun}}
}
\examples{
# List the current BASIC program.
LIST()
}

\name{UpperCode}
\alias{UpperCode}
\title{
Convert to Upper Case
}
\description{
Converts a \acronym{BASIC} program to upper case, except for any string
literals.
}
\usage{
UpperCode(p)
}
\arguments{
  \item{p}{
A \acronym{BASIC} program listing, as a character vector.
}
}
\value{
Returns the converted listing, as a character vector.
}
\seealso{
\code{\link{LowerCode}}
}
\examples{
# Convert a program to upper case.
UpperCode(c('10 let x=x+1', '20 print "Hello, World!"'))
}

\name{LowerCode}
\alias{LowerCode}
\title{
Convert to Lower Case
}
\description{
Converts a \acronym{BASIC} program to lower case, except for any string
literals.
}
\usage{
LowerCode(p)
}
\arguments{
  \item{p}{
A \acronym{BASIC} program listing, as a character vector.
}
}
\value{
Returns the converted listing, as a character vector.
}
\seealso{
\code{\link{UpperCode}}
}
\examples{
# Convert a program to lower case.
LowerCode(c('10 LET X=X+1', '20 PRINT "Hello, World!"'))
}

\name{brassica-package}
\alias{brassica-package}
\alias{brassica}
\docType{package}
\title{
BASIC Interpreter
}
\description{
Runs 1970s \acronym{BASIC} programs.
}
\details{
Interprets and executes a subset of early (1975) Altair/Microsoft
\acronym{BASIC}, plus some generalisations and extensions.
Enables various programs of historical interest to be run in their primal form.
A selection of public-domain examples are included.
}
\author{
Mike Lee
}
\seealso{
\code{\link{RUN}}
}
\examples{
require(brassica)

\dontrun{
# Load and run the 'Wumpus' program.
RUN("WUMPUS")
}
}
\keyword{BASIC}
\keyword{interpreter}
\keyword{package}
